grammar core;

synthesized attribute io :: IO;
synthesized attribute stringList :: StringList;

nonterminal IOBoolean with {io, bValue};
nonterminal IOInteger with {io, iValue};
nonterminal IOString with {io, sValue};
nonterminal IOStringList with {io, stringList};

synthesized attribute sValue :: String;
synthesized attribute bValue :: Boolean;
synthesized attribute iValue :: Integer;


abstract production ioBoolean
top::IOBoolean ::= i::IO b::Boolean
{
  top.io = i;
  top.bValue = b;
}

abstract production ioString
top::IOString ::= i::IO s::String
{
  top.io = i;
  top.sValue = s;
}

abstract production ioInteger
top::IOInteger ::= i::IO int::Integer
{
  top.io = i;
  top.iValue = int;
}

abstract production ioStringList
top::IOStringList ::= i::IO sl::StringList
{
  top.io = i;
  top.stringList = sl'';
}
