grammar silver:analysis:agnosis:core;
import silver:base:core;

attribute pInNames occurs on AspectSignature, AspectRHS, AspectRHSElem;
attribute outName occurs on AspectSignature, AspectLHS, AspectLHSElem;


aspect production aspectAGDcl
 top::AGDcl ::=
   a::Aspect_kwd p::Production_kwd id::QName ns::AspectSignature
   body::ProductionBody
{
  top.agnosis = cons(pDclData(makeName(fName), ns.pInNames, ns.outName), body.agnosis);
  body.thisName = makeName(fName);
  body.fullSignatureNames = ns.fullSigNames;
}


aspect production aspectSignatureEmptyRHS
top::AspectSignature ::= lhs::AspectLHS kwd::CCEQ_t
{
  top.pInNames = [];
  top.outName = lhs.outName;
  top.fullSigNames = lhs.fullSigNames;
}

aspect production aspectSignature
top::AspectSignature ::= lhs::AspectLHS kwd::CCEQ_t rhs::AspectRHS 
{
  top.pInNames = rhs.pInNames;
  top.outName = lhs.outName;
  top.fullSigNames = lhs.fullSigNames +++ rhs.fullSigNames;
}

aspect production aspectLHSSingle
top::AspectLHS ::= lhs::AspectLHSElem
{
  top.outName = lhs.outName;
  top.fullSigNames = lhs.fullSigNames;
}

aspect production aspectLHSElem
top::AspectLHSElem ::= id::Id_t
{
  top.outName = makeName(rType.typeName);
  top.fullSigNames = [rName];
}

aspect production aspectLHSElemFull
top::AspectLHSElem ::= id::Id_t kwd::HasType_t t::Type
{
  top.outName = makeName(t.typerep.typeName);
  top.fullSigNames = [rName];
}

aspect production aspectRHSEmpty
top::AspectRHS ::=
{
  top.pInNames = [];
  top.fullSigNames = [];
}

aspect production aspectRHSSingle
top::AspectRHS ::= rhs::AspectRHSElem
{
  top.pInNames = rhs.pInNames;
  top.fullSigNames = rhs.fullSigNames;
}

aspect production aspectRHSCons
top::AspectRHS ::= h::AspectRHSElem t::AspectRHS
{
  top.pInNames = h.pInNames +++ t.pInNames;
  top.fullSigNames = h.fullSigNames +++ t.fullSigNames;
}

aspect production aspectRHSElem
top::AspectRHSElem ::= id::Id_t
{
  top.pInNames = if rType.isNonTerminal 
		then [ntDclData(makeName(rType.typeName))]
		else [tDclData(makeName(rType.typeName))];

  top.fullSigNames = [rName];
}

aspect production aspectRHSElemFull
top::AspectRHSElem ::= id::Id_t kwd::HasType_t t::Type
{
  top.pInNames = if t.typerep.isNonTerminal 
		then [ntDclData(makeName(t.typerep.typeName))]
		else [tDclData(makeName(t.typerep.typeName))];

  top.fullSigNames = [rName];
}

