grammar silver:analysis:agnosis:core;
import silver:base;

aspect production defaultNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.agnosis = nonTerminalAgnosis(fName, top.globalEnv, top.env);
}

aspect production defaultClosedNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.agnosis = nonTerminalAgnosis(fName, top.globalEnv, top.env);
}

aspect production defaultStartNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.agnosis = cons(startDclData(makeName(fName)), nonTerminalAgnosis(fName, top.globalEnv, top.env));
}

aspect production closeNonterminalDcl
top::AGDcl ::= c::Close_kwd q::QName  s::Semi_t
{
  top.agnosis = [];
}

function nonTerminalAgnosis
[AgData] ::= fName::String ge::Decorated Env e::Decorated Env
{
  local attribute decorating :: [Decorated EnvItem];
  decorating = getAllOccuringOn(fName, ge);
  
  return cons(ntDclData(makeName(fName)), makeAttrAgData(makeName(fName), decorating, e));
}


function makeAttrAgData
[AgData] ::= ntN::String atts::[Decorated EnvItem] e::Decorated Env
{
  local attribute atN :: String;
  atN = makeName(head(atts).itemName);

  local attribute atT :: String;
  atT = if head(atts).typerep.isNonTerminal 
	then "AttrHigher (NT \"" ++ makeName(head(atts).typerep.typeName) ++ "\")"
	else if head(atts).typerep.isDecorated
	then "AttrRef (NT \"" ++ makeName(head(atts).typerep.typeName) ++ "\")"
	else "AttrScalar";

  local attribute atD :: String;
  atD = if isSynthesized(head(atts).itemName, e) then "Synthesized" else "Inherited";

  local attribute item :: [AgData];
  item = if null(atts) then [] else [attrDclData(ntN, atN, atT, atD)];

  return item +++ if null(atts) then [] else makeAttrAgData(ntN, tail(atts), e);
}
