grammar silver:analysis:termination:core;
import silver:base;
import silver:utils:command;
import core;


aspect production run
top::RunUnit ::= iIn::IO args::String p::Production(Root ::= String)
{
  postOps <- [ printTerminationRules (grammars) ];
}

abstract production printTerminationRules
top::Unit ::= specs::[GrammarSpec]
{
  forwards to printTerminationRulesHelper (specs, 0)
	with {
		ioIn =  print ("[" ++ printVariables (top.numberOfVariables) ++ "]\n", top.ioIn);
	};
}

synthesized attribute numberOfVariables :: Integer occurs on Unit;

abstract production printTerminationRulesHelper
top::Unit ::= specs::[GrammarSpec] lastVariableSoFar::Integer
{
  local attribute rules :: String;
  rules = head(specs).rootSpec.terminationRules;

  local attribute noOfVariables :: Integer;
  noOfVariables = if (head(specs).rootSpec.LHSVariableLastIndex > lastVariableSoFar) 
			then head(specs).rootSpec.LHSVariableLastIndex 
			else lastVariableSoFar;

  local attribute i :: IO;
  i = print (if length (rules) == 0 then "" else (rules ++ "\n"), top.ioIn);

  local attribute recurse :: Unit;
  recurse = printTerminationRulesHelper (tail(specs), noOfVariables);
  recurse.ioIn = i;

  top.io = if null(specs) then top.ioIn else recurse.io;
  top.numberOfVariables = if null (specs) then lastVariableSoFar else recurse.numberOfVariables;

  top.code = 0;
  top.order = 1;
}
