grammar silver:analysis:termination:core;
import silver:base:core;


aspect production lengthFunction
top::Expr ::= l::Length_kwd lp::LParen_t e::Expr rp::RParen_t
{
  top.terminationRuleRHS = e.terminationRuleRHS;
}

aspect production indexOfFunction
top::Expr ::= i::IndexOf_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_binary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ")";
}

aspect production subStringFunction
top::Expr ::= s::SubString_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_ternary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ", " ++ e3.terminationRuleRHS ++ ")";
}

aspect production errorFunction
top::Expr ::= er::Error_kwd l::LParen_t e::Expr r::RParen_t
{
  top.terminationRuleRHS = e.terminationRuleRHS;
}

aspect production stringToIntFunction
top::Expr ::= t::ToInt_kwd l::LParen_t e::Expr r::RParen_t
{
  top.terminationRuleRHS = e.terminationRuleRHS;
}

aspect production stringToFloatFunction
top::Expr ::= t::ToFloat_kwd l::LParen_t e::Expr r::RParen_t
{
  top.terminationRuleRHS = e.terminationRuleRHS;
}

aspect production numToStringFunction
top::Expr ::= t::ToString_kwd l::LParen_t e::Expr r::RParen_t
{
  top.terminationRuleRHS = e.terminationRuleRHS;
}

aspect production newFunction
top::Expr ::= n::New_kwd l::LParen_t e::Expr r::RParen_t
{
  top.terminationRuleRHS = e.terminationRuleRHS;
}

aspect production terminalFunction
top::Expr ::= term::Terminal_kwd l::LParen_t t::Type c::Comma_t e::Expr r::RParen_t
{
  top.terminationRuleRHS = e.terminationRuleRHS;
}

aspect production terminalFunction2
top::Expr ::= term::Terminal_kwd l::LParen_t t::Type c1::Comma_t e1::Expr c2::Comma_t e2::Expr c3::Comma_t e3::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_ternary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ", " ++ e3.terminationRuleRHS ++ ")";
}
