grammar silver:analysis:termination:core;
import silver:base:core;

attribute terminationRules occurs on ProductionBody, ProductionStmts, ProductionStmt, AttributeDef;
synthesized attribute generateSynRule :: Boolean occurs on LHSExpr;

aspect production emptyProductionBody
top::ProductionBody ::= 
{
  top.terminationRules = "";
}

aspect production defaultProductionBody
top::ProductionBody ::= stmts::ProductionStmts
{
  top.terminationRules = stmts.terminationRules;
}

aspect production productionStmtsNone
top::ProductionStmts ::= 
{
  top.terminationRules = "";
}

aspect production productionStmtsSingle
top::ProductionStmts ::= stmt::ProductionStmt
{
  top.terminationRules = stmt.terminationRules;
}

aspect production productionStmtsCons
top::ProductionStmts ::= h::ProductionStmt t::ProductionStmts
{
  top.terminationRules = h.terminationRules ++ t.terminationRules;
}

aspect production productionStmtsAppend
top::ProductionStmts ::= h::ProductionStmts t::ProductionStmts
{
  top.terminationRules = h.terminationRules ++ t.terminationRules;
}

aspect production forwardsDcl
top::ProductionStmt ::= f::Forwards_kwd t::To_kwd e::Expr s::Semi_t
{
  top.terminationRules = top.terminationRuleLHS ++ " -> " ++ e.terminationRuleRHS ++ "\n";
}

aspect production forwardsDclWith
top::ProductionStmt ::= f::Forwards_kwd t::To_kwd e::Expr w::With_kwd l::LCurly_t inh::ForwardInh r::RCurly_t s::Semi_t
{
  top.terminationRules = top.terminationRuleLHS ++ " -> " ++ e.terminationRuleRHS ++ "\n";
}

aspect production forwardingDclWith
top::ProductionStmt ::= f::Forwarding_kwd w::With_kwd l::LCurly_t inh::ForwardInh r::RCurly_t s::Semi_t
{
  top.terminationRules = "";
}

aspect production stmtToAttrDef
top::ProductionStmt ::= a::AttributeDef
{
  top.terminationRules = a.terminationRules;
}

aspect production attributeDclLocal
top::ProductionStmt ::= l::Local_kwd  at::Attribute_kwd a::Id_t 
                        ht::HasType_t te::Type  s::Semi_t
{
  top.terminationRules = "";
}

aspect production attrDef
top::AttributeDef ::= lhs::LHSExpr e::Expr
{
  -- only if it's local or synthesized lhs, and higher-order
  top.terminationRules = if lhs.generateSynRule then top.terminationRuleLHS ++ " -> " ++ e.terminationRuleRHS ++ "\n" else "";
}

aspect production lhsExprOne
top::LHSExpr ::= id::Id_t
{  
  -- assume it's local
  top.generateSynRule = top.typerep.isNonTerminal || top.typerep.isDecorated;
}

aspect production lhsExprTwo
top::LHSExpr ::= id::Id_t d::Dot_t q::QName
{
  -- lhs and synthesized		
  top.generateSynRule = !null(fNames2) && id.lexeme == head(top.signatureNames) && isSynthesized(fName2, top.env) && (top.typerep.isNonTerminal || top.typerep.isDecorated);
}
