grammar silver:analysis:termination:core;
import silver:base:core;

synthesized attribute terminationRules :: String;
attribute terminationRules occurs on Root, AGDcls, AGDcl;
attribute LHSVariableLastIndex occurs on Root, AGDcls, AGDcl;

aspect production root
top::Root ::= gdcl::GrammarDcl ims::ImportExportStmts  ags::AGDcls
{
  top.terminationRules = ags.terminationRules;
  top.LHSVariableLastIndex = ags.LHSVariableLastIndex;
}

aspect production agDclsOne
top::AGDcls ::= ag::AGDcl
{
  top.terminationRules = ag.terminationRules;
  top.LHSVariableLastIndex = ag.LHSVariableLastIndex;
}

aspect production agDclsCons
top::AGDcls ::= h::AGDcl t::AGDcls
{
  top.terminationRules = h.terminationRules ++ t.terminationRules;
  top.LHSVariableLastIndex = if h.LHSVariableLastIndex > t.LHSVariableLastIndex then h.LHSVariableLastIndex else t.LHSVariableLastIndex;
}

aspect production agDclSeq
top::AGDcl ::= ag1::AGDcl ag2::AGDcl
{
  top.terminationRules = ag1.terminationRules ++ ag2.terminationRules;
  top.LHSVariableLastIndex = if ag1.LHSVariableLastIndex > ag2.LHSVariableLastIndex then ag1.LHSVariableLastIndex else ag2.LHSVariableLastIndex;
}

aspect production agDclNone
top::AGDcl ::=
{
  top.terminationRules = "";
  top.LHSVariableLastIndex = 0;
}
