grammar silver:analysis:termination:core;

--function generateTerminationRulesFromMultipleRHSs
--String ::= lhs::String rhss::[ String ] 
--{
--  return if null (rhss)
--	 then ""
--	 else lhs ++ " -> " ++ head (rhss) ++ "\n" ++ generateTerminationRulesFromMultipleRHSs (lhs, tail (rhss));
--}

function printVariables
String ::= i::Integer {
  return if i < 1
	 then ""
	 else if i == 1
	 then "x_1"
	 else printVariables (i - 1) ++ ", x_" ++ toString (i);
}

function printVariables2
String ::= vars::[ String ] {
  return if null (vars)
	 then ""
	 else if null (tail (vars))
	 then head (vars)
	 else head (vars) ++ ", " ++ printVariables2 (tail (vars));
}

function uniqueVariables
[ String ] ::= vars::[ String ] {
  return if null (vars)
	 then []
	 else if memberVariables (head (vars), tail (vars))
	 then uniqueVariables (tail (vars))
	 else (head (vars) ::: uniqueVariables (tail (vars)));
}

function memberVariables
Boolean ::= elem::String vars::[ String ] {
  return if null (vars)
	 then false
	 else if elem == head (vars)
	 then true
	 else memberVariables (elem, tail (vars));
}

nonterminal StringPair with firstString, secondString;
synthesized attribute firstString :: String;
synthesized attribute secondString :: String;

abstract production string_pair
top::StringPair ::= s1::String s2::String {
  top.firstString = s1;
  top.secondString = s2;
}

function lookupTerminationRuleVarBinding
String ::= elem::String vars::[ StringPair ] {
  return if null (vars)
	 then "UnknownVariable"
	 else if head (vars).firstString == elem
	 then head (vars).secondString
	 else lookupTerminationRuleVarBinding (elem, tail (vars));
}
