grammar silver:analysis:termination:misc;
import silver:analysis:termination:core;
import silver:base:core;
import silver:base:type:io;

aspect production isFileFunction
top::Expr ::= i::IsFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_binary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ")";
}

aspect production isDirectoryFunction
top::Expr ::= i::IsDirectory_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_binary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ")";
}

aspect production readFunction
top::Expr ::= r::ReadFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr rp::RParen_t
{
  top.terminationRuleRHS = "dead_binary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ")";
}

aspect production cwdFunction
top::Expr ::= c::CWD_kwd l::LParen_t e::Expr r::RParen_t
{
  top.terminationRuleRHS = e.terminationRuleRHS;
}

aspect production envVarFunction
top::Expr ::= e::EnvVar_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_binary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ")";
}

aspect production systemFunction
top::Expr ::= s::System_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_binary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ")";
}

aspect production writeFunction
top::Expr ::= w::WriteFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{  
  top.terminationRuleRHS = "dead_ternary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ", " ++ e3.terminationRuleRHS ++ ")";
}

aspect production appendFunction
top::Expr ::= a::AppendFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_ternary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ", " ++ e3.terminationRuleRHS ++ ")";
}

aspect production printFunction
top::Expr ::= p::Print_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_binary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ")";
}

aspect production listContentsFunction
top::Expr ::= li::ListContents_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.terminationRuleRHS = "dead_binary (" ++ e1.terminationRuleRHS ++ ", " ++ e2.terminationRuleRHS ++ ")";
}

aspect production unsafeIOFunction
top::Expr ::= u::UnsafeIO_kwd
{  
  top.terminationRuleRHS = "dead_unary";
}

aspect production genIntFunction
top::Expr ::= g::GenInt_kwd l::LParen_t r::RParen_t
{
  top.terminationRuleRHS = "dead_unary";
}
