grammar silver:analysis:termination:misc;
import silver:analysis:termination:core;
import silver:base:core;
import silver:extension:list;

aspect production emptyList
top::Expr ::= lb::LSqr_t rb::RSqr_t
{
  top.terminationRuleRHS = "dead_primitive";
}

aspect production emptyListWType
top::Expr ::= lb::LSqr_t ht::HasType_t t::Type rb::RSqr_t
{
  top.terminationRuleRHS = "dead_primitive";
}

aspect production fullList
top::Expr ::= lb::LSqr_t es::Exprs rb::RSqr_t
{ 
  top.terminationRuleRHS = "dead_list" ++ (if es.terminationRuleRHS == "" then "" else "_" ++ toString (es.exprCount) ++ " (" ++ es.terminationRuleRHS ++ ")");
}

aspect production consList
top::Expr ::= ck::Cons_t lp::LParen_t h::Expr c::Comma_t t::Expr rp::RParen_t 
{ 
  top.terminationRuleRHS = "dead_binary (" ++ h.terminationRuleRHS ++ ", " ++ t.terminationRuleRHS ++ ")";
}

aspect production appendList
top::Expr ::= l::Decorated Expr o::AppendOp_t r::Decorated Expr
{ 
  top.terminationRuleRHS = "dead_binary (" ++ l.terminationRuleRHS ++ ", " ++ r.terminationRuleRHS ++ ")";
}

aspect production nullList
top::Expr ::= n::Null_t lp::LParen_t l::Expr rp::RParen_t 
{ 
  top.terminationRuleRHS = l.terminationRuleRHS;
}

aspect production headList
top::Expr ::= h::Head_t lp::LParen_t l::Expr rp::RParen_t 
{ 
  top.terminationRuleRHS = l.terminationRuleRHS;
}

aspect production tailList
top::Expr ::= t::Tail_t lp::LParen_t l::Expr rp::RParen_t 
{ 
  top.terminationRuleRHS = l.terminationRuleRHS;
}

