grammar silver:analysis:typechecking:core;
import silver:base;
import core only bValue;

aspect production productionDcl
 top::AGDcl ::=
   a::Abstract_kwd p::Production_kwd id::Id_t ns::ProductionSignature
   body::ProductionBody
{
  top.typeErrors = body.typeErrors;
}

aspect production aspectAGDcl
 top::AGDcl ::=
   a::Aspect_kwd p::Production_kwd id::QName ns::AspectSignature
   body::ProductionBody
{
  local attribute ip :: Boolean;
  ip = !null(prods) && head(prods).typerep.isProduction;

  local attribute sigOkay :: Boolean;
  sigOkay = ip && (genListEquals(head(prods).typerep.inputTypes, tail(ns.sigTypes)))
	       && (head(prods).typerep.outputType.typeEquals(head(prods).typerep.outputType, head(ns.sigTypes)).bValue);

  local attribute ter :: String;
  ter = if !sigOkay
        then top.location ++ "Error: Aspect for '" ++ id.name ++ "' does not have the right signature.\n"
        else "";	

  top.typeErrors = ter ++ body.typeErrors;
}
