grammar silver:analysis:typechecking:type:io;
import silver:analysis:typechecking:core;
import silver:base;



aspect production isFileFunction
top::Expr ::= i::IsFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  local attribute e1_error :: String;
  e1_error =   if (e1.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: First opperand to isFile must be of type String.\n";


  local attribute e2_error :: String;
  e2_error =   if (e2.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Second opperand to isFile must be of type IO.\n";

  top.typeErrors = e1_error ++ e2_error ++ e1.typeErrors ++ e2.typeErrors;
}

aspect production isDirectoryFunction
top::Expr ::= i::IsDirectory_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  local attribute e1_error :: String;
  e1_error =   if (e1.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: First opperand to isDirectory must be of type String.\n";


  local attribute e2_error :: String;
  e2_error =   if (e2.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Second opperand to isDirectory must be of type IO.\n";

  top.typeErrors = e1_error ++ e2_error ++ e1.typeErrors ++ e2.typeErrors;
}

aspect production readFunction
top::Expr ::= r::ReadFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr rp::RParen_t
{
  local attribute e1_error :: String;
  e1_error =   if (e1.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: First opperand to readFile must be of type String.\n";


  local attribute e2_error :: String;
  e2_error =   if (e2.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Second opperand to readFile must be of type IO.\n";

  top.typeErrors = e1_error ++ e2_error ++ e1.typeErrors ++ e2.typeErrors;
}

aspect production cwdFunction
top::Expr ::= c::CWD_kwd l::LParen_t e::Expr r::RParen_t
{
  local attribute e1_error :: String;
  e1_error =   if (e.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Second opperand to readFile must be of type IO.\n";

  top.typeErrors = e1_error ++ e.typeErrors;
}



aspect production envVarFunction
top::Expr ::= e::EnvVar_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{

  local attribute e1_error :: String;
  e1_error =   if (e1.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: First opperand to readFile must be of type String.\n";


  local attribute e2_error :: String;
  e2_error =   if (e2.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Second opperand to readFile must be of type IO.\n";

  top.typeErrors = e1_error ++ e2_error ++ e1.typeErrors ++ e2.typeErrors;
}

aspect production systemFunction
top::Expr ::= s::System_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  local attribute e1_error :: String;
  e1_error =   if (e1.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: First opperand to readFile must be of type String.\n";


  local attribute e2_error :: String;
  e2_error =   if (e2.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Second opperand to readFile must be of type IO.\n";

  top.typeErrors = e1_error ++ e2_error ++ e1.typeErrors ++ e2.typeErrors;
}


aspect production writeFunction
top::Expr ::= w::WriteFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{

  local attribute e1_error :: String;
  e1_error =   if (e1.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: First opperand to writeFile must be of type String.\n";


  local attribute e2_error :: String;
  e2_error =   if (e2.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: Second opperand to writeFile must be of type String.\n";


  local attribute e3_error :: String;
  e3_error =   if (e3.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Third opperand to writeFile must be of type IO.\n";

  top.typeErrors = e1_error ++ e2_error ++ e3_error ++ e1.typeErrors ++ e2.typeErrors ++ e3.typeErrors;

}

aspect production appendFunction
top::Expr ::= a::AppendFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{

  local attribute e1_error :: String;
  e1_error =   if (e1.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: First opperand to appendFile must be of type String.\n";


  local attribute e2_error :: String;
  e2_error =   if (e2.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: Second opperand to appendFile must be of type String.\n";


  local attribute e3_error :: String;
  e3_error =   if (e3.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Third opperand to appendFile must be of type IO.\n";

  top.typeErrors = e1_error ++ e2_error ++ e3_error ++ e1.typeErrors ++ e2.typeErrors ++ e3.typeErrors;
}





aspect production printFunction
top::Expr ::= p::Print_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{

  local attribute e1_error :: String;
  e1_error =   if (e1.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: First opperand to print must be of type String.\n";


  local attribute e2_error :: String;
  e2_error =   if (e2.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Second opperand to print must be of type IO.\n";

  top.typeErrors = e1_error ++ e2_error ++ e1.typeErrors ++ e2.typeErrors;

}

aspect production listContentsFunction
top::Expr ::= li::ListContents_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{

  local attribute e1_error :: String;
  e1_error =   if (e1.typerep.typeName == "String") 
	       then ""
	       else top.location ++ "Error: First opperand to listContents must be of type String.\n";


  local attribute e2_error :: String;
  e2_error =   if (e2.typerep.typeName == "IO") 
	       then ""
	       else top.location ++ "Error: Second opperand to listContents must be of type IO.\n";

  local attribute ref :: [Decorated EnvItem];
  ref = getTypeDcl("core:StringList", top.env);

  local attribute error_sl :: String;
  error_sl = if !null(ref) then ""
	     else top.location ++ "Error: StringList not found in the environment.  You must import core without renaming StringList.\n";

  top.typeErrors = e1_error ++ e2_error ++ e1.typeErrors ++ e2.typeErrors;
}

aspect production unsafeIOFunction
top::Expr ::= u::UnsafeIO_kwd
{  
   top.typeErrors = "";
}

aspect production genIntFunction
top::Expr ::= g::GenInt_kwd l::LParen_t r::RParen_t
{
  top.typeErrors = "";
}