grammar silver:base:core;
export silver:base:core;

-- Punctuation
terminal Semi_t    /[\;]/ lexer precedence = 5 ;
terminal Colon_t   /[\:]/ lexer precedence = 5 ;
terminal Equal_t   /[\=]/ lexer precedence = 5 ;
terminal Comma_t   /[\,]/ lexer precedence = 5, precedence = 4 ;
terminal Dot_t   /[\.]/ lexer precedence = 5, precedence = 25, association = left;

terminal LParen_t  /[\(]/ lexer precedence = 5, precedence = 24;
terminal RParen_t  /[\)]/ lexer precedence = 5 ;
terminal LCurly_t  /[\{]/ lexer precedence = 5 ;
terminal RCurly_t  /[\}]/ lexer precedence = 5 ;

terminal HasType_t /[\:][\:]/ lexer precedence = 6 ;

terminal Int_t /[0-9]+/ lexer precedence = 2 ;
terminal Id_t /[A-Za-z][A-Za-z0-9\_]*/ lexer precedence = 2 ;

ignore terminal WhiteSpace /[\n\t\ ]+/ lexer precedence = 0;


--ignore terminal comments /abc/;
ignore terminal comments /([\-][\-].*)/ ;
--terminal String_t /def/; 
terminal String_t /[\"]([^\"\\]|[\\][\"]|[\\][\\]|[\\]n|[\\]r|[\\]t)*[\"]/ lexer precedence = 5;
--terminal RegExpr_t /ghi/;


terminal RegExpr_t 
	/([\/]([^\/\n]|([\\][\/]))*[\/]+)/ 
--	/([\/]([^\/]|([\/]+[^\/]))*[\/]+)/ 
lexer precedence = 4;




--ignore terminal comments /( [\{] [\-] ([^\-] | [\r\n] | ([\-]+ ([^\-\}] | [\r\n])))*  [\-]+ [\}]) | ([\-] [\-] .*) / ;
