grammar silver:base:core;
import core;



synthesized attribute isAttributeDef :: Boolean;
synthesized attribute isLocalDcl :: Boolean;
synthesized attribute isForwardsDcl :: Boolean;
synthesized attribute isForwardingDcl :: Boolean;
synthesized attribute stmtList :: [StmtRep];
synthesized attribute lhsExpr :: Decorated LHSExpr;
synthesized attribute rhsExpr :: Decorated Expr;
nonterminal StmtRep with {isAttributeDef, isLocalDcl, isForwardsDcl, isForwardingDcl, lhsExpr, rhsExpr, fullName, name, typerep, stmtList, pp};


abstract production localDclStmtRep
top::StmtRep ::= lname::String lfname::String ltr::Decorated TypeRep
{
  top.pp = "local stmt rep : " ++ lname ++ " " ++ lfname;
  top.name = lname;
  top.fullName = lfname;
  top.typerep = ltr;

  top.isLocalDcl = true;

  top.isForwardingDcl = false;
  top.isForwardsDcl = false;
  top.isAttributeDef = false;

  forwards to defaultStmtRep();
}


abstract production forwardsDclStmtRep
top::StmtRep ::= ftr::Decorated TypeRep sl::[StmtRep] frhs::Decorated Expr
{
  top.pp = "forwards dcl";

  top.stmtList = sl'';
  top.typerep = ftr;
  top.rhsExpr = frhs;

  top.isForwardsDcl = true;

  top.isForwardingDcl = false;
  top.isLocalDcl = false;
  top.isAttributeDef = false;

  forwards to defaultStmtRep();
}


abstract production forwardingDclStmtRep
top::StmtRep ::= sl::[StmtRep]
{
  top.pp = "forwards dcl stmt rep";

  top.stmtList = sl'';

  top.isForwardingDcl = true;

  top.isForwardsDcl = false;
  top.isLocalDcl = false;
  top.isAttributeDef = false;

  forwards to defaultStmtRep();
}


abstract production attributeDefStmtRep
top::StmtRep ::= lhs::Decorated LHSExpr rhs::Decorated Expr
{

  top.pp = "attribute def : "  ++ lhs.pp ++ " " ++ rhs.pp;

  top.lhsExpr = lhs;
  top.rhsExpr = rhs;

  top.isAttributeDef = true;

  top.isForwardingDcl = false;
  top.isForwardsDcl = false;
  top.isLocalDcl = false;

  forwards to defaultStmtRep();
}

abstract production defaultStmtRep
top::StmtRep ::= 
{
  top.pp = "default";
  top.name = "";
  top.fullName = "";
  top.typerep = topTypeRep();

  top.isLocalDcl = false;
  top.isForwardingDcl = false;
  top.isForwardsDcl = false;
  top.isAttributeDef = false;
}