grammar silver:base:core;

terminal CCEQ_t /[\:][\:][\=]/ lexer precedence = 7;

terminal Integer_kwd  /Integer/ lexer precedence = 5 ;
terminal Float_kwd    /Float/   lexer precedence = 5 ;
terminal String_kwd   /String/  lexer precedence = 5 ;
terminal Boolean_kwd  /Boolean/ lexer precedence = 5 ;

nonterminal Type with {pp, location, grammarName, typerep, env, errors} ;

-- Primitive Types
------------------
concrete production integerType
top::Type ::= i::Integer_kwd
{
  top.pp = "Integer" ;
  top.typerep = integerTypeRep();
  top.location = "[line: " ++ toString(i.line) ++ ", column: " ++ toString(i.column) ++ "] ";
  top.errors = "";
}

concrete production floatType
top::Type ::= f::Float_kwd
{
  top.pp = "Float" ;
  top.typerep = floatTypeRep();
  top.location = "[line: " ++ toString(f.line) ++ ", column: " ++ toString(f.column) ++ "] ";
  top.errors = "";
}

concrete production stringType
top::Type ::= s::String_kwd
{
  top.pp = "String" ;
  top.typerep = stringTypeRep();
  top.location = "[line: " ++ toString(s.line) ++ ", column: " ++ toString(s.column) ++ "] ";
  top.errors = "";
}

concrete production booleanType
top::Type ::= b::Boolean_kwd
{
  top.pp = "Boolean" ;
  top.typerep = booleanTypeRep();
  top.location = "[line: " ++ toString(b.line) ++ ", column: " ++ toString(b.column) ++ "] ";
  top.errors = "";
}


