grammar silver:base:cs:default;
import silver:base:core;
import silver:base:type;

aspect production stringLength
top::Expr ::= e::Decorated Expr
{
  top.parserUses = e.parserUses;
}

aspect production unknownLength
top::Expr ::= e::Decorated Expr
{
  top.parserUses = e.parserUses;
}

aspect production indexOfFunction
top::Expr ::= i::IndexOf_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses;
}
aspect production subStringFunction
top::Expr ::= s::SubString_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses ++ e3.parserUses;
}
aspect production errorFunction
top::Expr ::= er::Error_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}
aspect production stringToIntFunction
top::Expr ::= t::ToInt_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}
aspect production stringToFloatFunction
top::Expr ::= t::ToFloat_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}
aspect production numToStringFunction
top::Expr ::= t::ToString_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}

aspect production ftoiFunction
top::Expr ::= t::FTOI_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}

aspect production itofFunction
top::Expr ::= t::ITOF_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}

aspect production isDigitFunction
top::Expr ::= t::IsDigit_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}

aspect production isAlphaFunction
top::Expr ::= t::IsAlpha_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}

aspect production isSpaceFunction
top::Expr ::= t::IsSpace_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}
aspect production isLowerFunction
top::Expr ::= t::IsLower_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}
aspect production isUpperFunction
top::Expr ::= t::IsUpper_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}
aspect production newFunction
top::Expr ::= n::New_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}
aspect production terminalFunction
top::Expr ::= term::Terminal_kwd l::LParen_t t::Type c::Comma_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}
aspect production terminalFunction2
top::Expr ::= term::Terminal_kwd l::LParen_t t::Type c1::Comma_t e1::Expr c2::Comma_t e2::Expr c3::Comma_t e3::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses ++ e3.parserUses;
}

aspect production isFileFunction
top::Expr ::= i::IsFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses;
}

aspect production isDirectoryFunction
top::Expr ::= i::IsDirectory_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses;
}

aspect production readFunction
top::Expr ::= r::ReadFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr rp::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses;
}

aspect production cwdFunction
top::Expr ::= c::CWD_kwd l::LParen_t e::Expr r::RParen_t
{
  top.parserUses = e.parserUses;
}

aspect production envVarFunction
top::Expr ::= e::EnvVar_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses;
}

aspect production systemFunction
top::Expr ::= s::System_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses;
}


aspect production writeFunction
top::Expr ::= w::WriteFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses ++ e3.parserUses;
}

aspect production appendFunction
top::Expr ::= a::AppendFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses ++ e3.parserUses;
}

aspect production printFunction
top::Expr ::= p::Print_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses;
}

aspect production listContentsFunction
top::Expr ::= li::ListContents_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.parserUses = e1.parserUses ++ e2.parserUses;
}

aspect production genIntFunction
top::Expr ::= g::GenInt_kwd l::LParen_t r::RParen_t
{
   top.parserUses = [];
}

aspect production unsafeIOFunction
top::Expr ::= u::UnsafeIO_kwd
{
  top.parserUses = [];
}

aspect production cast_t
top::Expr ::= cst::Cast_kwd e::Expr t_typerep::Decorated TypeRep
{
  top.parserUses = e.parserUses;
}
