grammar silver:base:cs:default;
import silver:base:core;

attribute terminalDcls occurs on ImportExportStmts;
attribute ruleDcls occurs on ImportExportStmts;
attribute hiddenSyntax occurs on ImportExportStmts;

concrete production nameListParser
top::NameList ::= p::Parse_kwd
{ 
  forwards to nameListOne(qNameId(terminal(Id_t, "parse")));
}

concrete production nameListConsParser
top::NameList ::= p::Parse_kwd  c::Comma_t  t::NameList
{
  forwards to nameListCons(qNameId(terminal(Id_t, "parse")), c, t'');
}

concrete production withElementParser
top::WithElem ::= nname::Parse_kwd a::As_kwd  id::Id_t 
{
  forwards to withElement(terminal(Id_t, "parse"), a, id);
}


aspect production importStmtsNone
top::ImportExportStmts ::=
{
  top.hasStartSymbol = false;
  top.terminalDcls = [];
  top.ruleDcls = [];
  top.hiddenSyntax = [];
}

aspect production importStmtsOne 
top::ImportExportStmts ::= im::ImportStmt
{
  top.hasStartSymbol = false;
  top.terminalDcls = [];
  top.ruleDcls = [];
  top.hiddenSyntax = [];
}

aspect production exportStmtsOne 
top::ImportExportStmts ::= ex::ExportStmt
{
  top.hasStartSymbol = false;
  top.terminalDcls = [];
  top.ruleDcls = [];
  top.hiddenSyntax = [];
}

aspect production importStmtsCons
top::ImportExportStmts ::= h::ImportStmt t::ImportExportStmts
{
  top.hasStartSymbol = t.hasStartSymbol;
  top.startName = t.startName;

  top.terminalDcls = t.terminalDcls;
  top.ruleDcls = t.ruleDcls;
  top.hiddenSyntax = t.hiddenSyntax;
}

aspect production exportStmtsCons
top::ImportExportStmts ::= h::ExportStmt t::ImportExportStmts
{
  top.hasStartSymbol = t.hasStartSymbol;
  top.startName = t.startName;

  top.terminalDcls = t.terminalDcls;
  top.ruleDcls = t.ruleDcls;
  top.hiddenSyntax = t.hiddenSyntax;
}

aspect production appendImportsExports
top::ImportExportStmts ::= fst::ImportExportStmts snd::ImportExportStmts
{
  top.hasStartSymbol = fst.hasStartSymbol || snd.hasStartSymbol;
  top.startName = if fst.hasStartSymbol then fst.startName else snd.startName;

  top.terminalDcls = fst.terminalDcls +++ snd.terminalDcls;
  top.ruleDcls = fst.ruleDcls +++ snd.ruleDcls;
  top.hiddenSyntax = fst.hiddenSyntax +++ snd.hiddenSyntax;
}