grammar silver:base:cs:default;

nonterminal ParserPrecSpec with {parserPrecedence, parserAssociation, precedenceName};

synthesized attribute precedenceName :: String;

abstract production precSpec
top::ParserPrecSpec ::= n::String prec::Integer assoc::String
{
  top.precedenceName = n;
  top.parserPrecedence = prec;
  top.parserAssociation = assoc;
}

function getParserPrecSpecTerminals
[ParserPrecSpec] ::= l::[TerminalSpec]
{
  return if null(l) 
	 then []
	 else [precSpec(head(l).terminalName, head(l).parserPrecedence, head(l).parserAssociation)] +++ getParserPrecSpecTerminals(tail(l));
}

function getParserPrecSpecRules
[ParserPrecSpec] ::= l::[RuleSpec]
{
  return if null(l) 
	 then []
	 else getParserPrecSpecRulesHelp(head(l).ruleRHSSpec) +++ getParserPrecSpecRules(tail(l));
}

function getParserPrecSpecRulesHelp
[ParserPrecSpec] ::= l::[RHSSpec]
{
  return if null(l) 
	 then []
	 else [precSpec(head(l).ruleName, head(l).parserPrecedence, "nonassoc")] +++ getParserPrecSpecRulesHelp(tail(l));
}