grammar silver:base:cs:default;
import silver:base:core;

attribute parserUses occurs on ProductionBody, ProductionStmts, ProductionStmt, AttributeDef, ForwardInh;

aspect production defaultProductionBody
top::ProductionBody ::= stmts::ProductionStmts
{
  top.parserUses = stmts.parserUses;
}

aspect production productionStmtsNone
top::ProductionStmts ::= 
{
  top.parserUses = [];
}

aspect production productionStmtsSingle
top::ProductionStmts ::= stmt::ProductionStmt
{
  top.parserUses = stmt.parserUses;
}

aspect production productionStmtsCons
top::ProductionStmts ::= h::ProductionStmt t::ProductionStmts
{
  top.parserUses = h.parserUses ++ t.parserUses;
}

aspect production productionStmtsAppend
top::ProductionStmts ::= h::ProductionStmts t::ProductionStmts
{
  top.parserUses = h.parserUses ++ t.parserUses;
}
aspect production forwardsDcl
top::ProductionStmt ::= f::Forwards_kwd t::To_kwd e::Expr s::Semi_t
{
  top.parserUses = e.parserUses;
}

aspect production forwardsDclWith
top::ProductionStmt ::= f::Forwards_kwd t::To_kwd e::Expr w::With_kwd l::LCurly_t inh::ForwardInh r::RCurly_t s::Semi_t
{
  top.parserUses = e.parserUses ++ inh.parserUses;
}

aspect production forwardingDclWith
top::ProductionStmt ::= f::Forwarding_kwd w::With_kwd l::LCurly_t inh::ForwardInh r::RCurly_t s::Semi_t
{
  top.parserUses = inh.parserUses;
}

aspect production forwardStmtsEmpty
top::ForwardInh ::= 
{
  top.parserUses = [];
}

aspect production forwardStmtsCons
top::ForwardInh ::= lhs::ForwardLHSExpr ekwd::Equal_t e::Expr s::Semi_t inh::ForwardInh
{ 
  top.parserUses = e.parserUses ++ inh.parserUses;
}


aspect production attributeDclLocal
top::ProductionStmt ::= l::Local_kwd  at::Attribute_kwd a::Id_t 
                        ht::HasType_t te::Type  s::Semi_t
{
  top.parserUses = [];
}

aspect production stmtToAttrDef
top::ProductionStmt ::= a::AttributeDef
{
  top.parserUses = a.parserUses;
}

aspect production attrDef
top::AttributeDef ::= lhs::LHSExpr e::Expr
{
  top.parserUses = e.parserUses;
}

