grammar silver:base:cs:default;
import silver:base:core;



aspect production productionDcl
 top::AGDcl ::=
   a::Abstract_kwd p::Production_kwd id::Id_t ns::ProductionSignature
   body::ProductionBody
{
  top.hasStartSymbol = false;

  top.parserUses = body.parserUses;
  top.terminalDcls = [];
  top.ruleDcls = [];
}

aspect production aspectAGDcl
 top::AGDcl ::=
   a::Aspect_kwd p::Production_kwd id::QName ns::AspectSignature
   body::ProductionBody
{
  top.hasStartSymbol = false;

  top.parserUses = body.parserUses;
  top.terminalDcls = [];
  top.ruleDcls = [];
}
terminal Concrete_kwd /concrete/ lexer precedence = 5;
concrete production concreteProductionDcl
 top::AGDcl ::= c::Concrete_kwd p::Production_kwd id::Id_t
   ns::ProductionSignature pm::OptProductionModifiers
   b::ProductionBody
{

  local attribute fName :: String;
  fName = top.grammarName.name ++ ":" ++ id.lexeme;

  top.terminalDcls = [];

  top.ruleDcls = [ruleSpec(head(ns.sigTypes).typeName, [rhsSpec(fName, getNames(tail(ns.sigTypes)),top.grammarName, pm)])];

  forwards to productionDcl(terminal(Abstract_kwd, "abstract", c.line, c.column), p, id, ns'', b'');
}


function getNames
[String] ::= l::[Decorated TypeRep]
{
  return if null(l) then [] else [head(l).typeName] +++ getNames(tail(l));
}

nonterminal OptProductionModifiers with {hasParserPrec, parserPrec};
concrete production optProductionModifiersNothing
top::OptProductionModifiers ::= 
{
  top.hasParserPrec = false;
  top.parserPrec = 0;
}

concrete production optProductionModifiersSomething
top::OptProductionModifiers ::= pm::ProductionModifiers
{
  top.hasParserPrec = pm.hasParserPrec;
  top.parserPrec = pm.parserPrec;
}

nonterminal ProductionModifiers with {hasParserPrec, parserPrec};
concrete production productionModifierSingle
top::ProductionModifiers ::= pm::ProductionModifier
{
  top.hasParserPrec = pm.hasParserPrec;
  top.parserPrec = pm.parserPrec; 
}

concrete production productionModifiersCons
top::ProductionModifiers ::= h::ProductionModifier c::Comma_t t::ProductionModifiers
{
  top.hasParserPrec = h.hasParserPrec || t.hasParserPrec ;
  top.parserPrec = if   h.hasParserPrec 
                   then h.parserPrec 
                   else if t.hasParserPrec
                        then t.parserPrec 
                        else 0 ;
}

nonterminal ProductionModifier with {hasParserPrec, parserPrec};
concrete production productionModifierPrecedence
top::ProductionModifier ::= p::Precedence_kwd e::Equal_t i::Int_t
{
  top.hasParserPrec = true;
  top.parserPrec = toInt(i.lexeme);
}
