grammar silver:base:cs:default;
import silver:base:core;

attribute hasStartSymbol occurs on Root, AGDcls, AGDcl;
attribute startName occurs on Root, AGDcls, AGDcl;

synthesized attribute terminalDcls :: [TerminalSpec];
synthesized attribute ruleDcls :: [RuleSpec];
synthesized attribute parserUses :: [String];

attribute parserUses occurs on Root, RootSpec, AGDcls, AGDcl;
attribute terminalDcls occurs on Root, RootSpec, AGDcls, AGDcl;
attribute ruleDcls occurs on Root, RootSpec, AGDcls, AGDcl;
attribute hiddenSyntax occurs on Root, RootSpec;

aspect production root
top::Root ::= gdcl::GrammarDcl ims::ImportExportStmts ags::AGDcls
{
  top.hasStartSymbol = ims.hasStartSymbol || ags.hasStartSymbol;
  top.startName = if ags.hasStartSymbol then ags.startName else ims.startName;

  top.parserUses = ags.parserUses;
  top.terminalDcls = ags.terminalDcls +++ ims.terminalDcls;
  top.ruleDcls = ags.ruleDcls +++ ims.ruleDcls;
  top.hiddenSyntax = ims.hiddenSyntax;
}

aspect production agDclsOne
top::AGDcls ::= ag::AGDcl
{
  top.parserUses = ag.parserUses;
  top.startName = ag.startName;
  top.hasStartSymbol = ag.hasStartSymbol;

  top.terminalDcls = ag.terminalDcls;
  top.ruleDcls = ag.ruleDcls ;
}

aspect production agDclsCons
top::AGDcls ::= h::AGDcl t::AGDcls
{
  top.parserUses = h.parserUses ++ t.parserUses;
  top.hasStartSymbol = h.hasStartSymbol || t.hasStartSymbol;
  top.startName = if h.hasStartSymbol then h.startName else t.startName;

  top.terminalDcls = h.terminalDcls +++ t.terminalDcls;
  top.ruleDcls = h.ruleDcls +++ t.ruleDcls;
}

aspect production agDclSeq
top::AGDcl ::= ag1::AGDcl ag2::AGDcl
{
  top.parserUses = ag1.parserUses ++ ag2.parserUses;
  top.hasStartSymbol = ag1.hasStartSymbol || ag2.hasStartSymbol;
  top.startName = if ag1.hasStartSymbol then ag1.startName else ag2.startName;

  top.terminalDcls = ag1.terminalDcls +++ ag2.terminalDcls;
  top.ruleDcls = ag1.ruleDcls +++ ag2.ruleDcls;
}

aspect production agDclNone
top::AGDcl ::=
{
  top.parserUses = [];
  top.hasStartSymbol = false;

  top.terminalDcls = [];
  top.ruleDcls = [];
}
