grammar silver:base:cs:default;

nonterminal TerminalSpec with {parserAssociation, parserPrecedence, lexerPrecedence, terminalName, terminalRegExpr, ignoreTerminal};

synthesized attribute ignoreTerminal :: Boolean;
synthesized attribute terminalName :: String;
synthesized attribute parserAssociation :: String;
synthesized attribute parserPrecedence :: Integer;
synthesized attribute lexerPrecedence :: Integer;
synthesized attribute terminalRegExpr :: String;

abstract production terminalSpec
top::TerminalSpec ::= fn::String ignored::Boolean regex::String
{
  top.ignoreTerminal = ignored;

  top.terminalName = fn;

  top.lexerPrecedence = 0;
  top.parserPrecedence = 0;
  top.parserAssociation = "nonassoc";

  top.terminalRegExpr = regex;
}

abstract production longTerminalSpec
top::TerminalSpec ::= fn::String ignored::Boolean tm::Decorated TerminalModifiers reg::String
{
  top.ignoreTerminal = ignored;

  top.terminalName = fn;

  top.lexerPrecedence = tm.lexerPrec;
  top.parserPrecedence = tm.parserPrec;
  top.parserAssociation = tm.parserAssoc;

  top.terminalRegExpr =  reg;
}


function terminalCheck
Boolean ::= s::String l::[TerminalSpec]
{
  return !null(l) && ( s == head(l).terminalName || terminalCheck(s, tail(l)));
}
