grammar silver:base:regex:abstractsyntax;

-- import silver:base:regex:concretesyntax;

synthesized attribute alex_regexpr :: String;

attribute alex_regexpr occurs on Regex_abst;
attribute alex_regexpr occurs on Range_abst;

aspect production regex_concat
combined::Regex_abst ::= first::Regex_abst rest::Regex_abst
{
     combined.alex_regexpr = first.alex_regexpr ++ rest.alex_regexpr;
}

aspect production regex_kleene
combined::Regex_abst ::= first::Regex_abst rest::Regex_abst
{
     combined.alex_regexpr = first.alex_regexpr ++ "*" ++ rest.alex_regexpr;
}

aspect production regex_plus
combined::Regex_abst ::= first::Regex_abst rest::Regex_abst
{
     combined.alex_regexpr = first.alex_regexpr ++ "+" ++ rest.alex_regexpr;
}

aspect production regex_optional
combined::Regex_abst ::= first::Regex_abst rest::Regex_abst
{
     combined.alex_regexpr = first.alex_regexpr ++ "?" ++ rest.alex_regexpr;
}

aspect production regex_choice
combined::Regex_abst ::= first::Regex_abst rest::Regex_abst
{
     combined.alex_regexpr = first.alex_regexpr ++ "|" ++ rest.alex_regexpr;
}

aspect production regex_empty
emp::Regex_abst ::=
{
     emp.alex_regexpr = "";
}

aspect production regex_wildcard
wildcard::Regex_abst ::=
{
     wildcard.alex_regexpr = ".";
}

aspect production regex_parenthesized
parenth::Regex_abst ::= nonparenth::Regex_abst
{
     parenth.alex_regexpr = "(" ++ nonparenth.alex_regexpr ++ ")";
}

aspect production regex_posCharrange
rangeRegex::Regex_abst ::= range::Range_abst
{
     rangeRegex.alex_regexpr = "[" ++ range.alex_regexpr ++ "]";
}

aspect production regex_negCharrange
rangeRegex::Regex_abst ::= range::Range_abst
{
     rangeRegex.alex_regexpr = "[^" ++ range.alex_regexpr ++ "]";
}

aspect production range_rangeunion
range::Range_abst ::= first::Range_abst rest::Range_abst
{
     range.alex_regexpr = first.alex_regexpr ++ rest.alex_regexpr;
}

aspect production range_loosechar
range::Range_abst ::= char::Regex_abst
{
     range.alex_regexpr = char.alex_regexpr;
}

aspect production range_rangechar
range::Range_abst ::= leastchar::Regex_abst greatestchar::Regex_abst
{
     range.alex_regexpr = leastchar.alex_regexpr ++ "-" ++ greatestchar.alex_regexpr;
}

aspect production range_empty
emp::Range_abst ::=
{
     emp.alex_regexpr = "";
}

aspect production regex_char
regex::Regex_abst ::= char::String
{
     local attribute re_alex :: String;
     re_alex = if char == "+" ||
                  char == "*" ||
                  char == "?" ||
                  char == "|" ||
                  char == "-" ||
                  char == "^" ||
                  char == "[" ||
                  char == "]" ||
                  char == "(" ||
                  char == ")" ||
                  char == "{" ||
                  char == "}" ||
                  char == "." ||
                  char == "_" ||
                  char == " " ||
                  char == "\\"
               then "\\" ++ char
               else if char == "\t"
                    then "\\t"
                    else char;

     regex.alex_regexpr = re_alex;
}

aspect production regex_escaped_char
regex::Regex_abst ::= char::String
{
     local attribute re_alex :: String;
     re_alex = if char == "\\+" ||
                  char == "\\*" ||
                  char == "\\?" ||
                  char == "\\|" ||
                  char == "\\-" ||
                  char == "\\^" ||
                  char == "\\[" ||
                  char == "\\]" ||
                  char == "\\(" ||
                  char == "\\)" ||
                  char == "\\{" ||
                  char == "\\}" ||
                  char == "\\." ||
                  char == "\\r" ||
                  char == "\\n" ||
                  char == "\\t" ||
                  char == "\\_" ||
                  char == "\\ " ||
                  char == "\\\\"
           -- EVW added these
           --       ||
           --       char == "\\,"  || 
           --       char == "\\\"" || 
           --       char == "\\#"  || 
           --       char == "\\;"  || 
           --       char == "\\/"  || 
           --       char == "\\<"  || 
           --       char == "\\>"  

          then char
          else substring(1,length(char),char);

     regex.alex_regexpr = re_alex;
}

