grammar silver:base:type:decorated;
import silver:base:core;

terminal Decorated_kwd /Decorated/ lexer precedence = 5;

-- references
-----------------------------------
concrete production refType
top::Type ::= r::Decorated_kwd q::QName
{
  top.pp = "Decorated " ++ q.pp;

  top.typerep = if null(types) then topTypeRep() else refTypeRep(head(types).typerep);
  top.location = q.location;

  top.errors = if null(types) 
	       then top.location ++ "Error: '" ++ q.name ++ "' is not bound to a type.\n"
	       else "";

  production attribute fNames :: [Decorated EnvItem];
  fNames = getFullNameDclOne(q.name, top.env);

  production attribute fName :: String;
  fName = if !null(fNames) then head(fNames).fullName else "FULL_NAME_NOT_DEFINED";

  production attribute types :: [Decorated EnvItem];
  types = getTypeDclOne(fName, top.env);
}