grammar silver:base:type:production;
import silver:base:core;

terminal CProduction_kwd /Production/ lexer precedence = 5;

concrete production prodType
top::Type ::= p::CProduction_kwd l::LParen_t sig::Signature r::RParen_t
{
  top.pp = "production ( " ++ sig.pp ++ " )";
  top.typerep = prodTypeRep(sig.inputTypes, sig.outputType);
  top.location = "[line: " ++ toString(p.line) ++ ", column: " ++ toString(p.column) ++ "] ";
  top.errors = sig.errors;
}

nonterminal Signature with {pp, location, outputType, inputTypes, grammarName, env, errors};

concrete production signatureEmptyRhs
top::Signature ::= t::Type kwd::CCEQ_t
{
  top.pp = t.pp ++ " ::=";
  top.location = t.location;

  top.outputType = t.typerep;
  top.inputTypes = [];

  top.errors = t.errors;
}

concrete production psignature
top::Signature ::= t::Type kwd::CCEQ_t list::TypeList 
{
  top.pp = t.pp ++ " ::= " ++ list.pp;
  top.location = t.location;

  top.outputType = t.typerep;
  top.inputTypes = list.inputTypes;
  top.errors = t.errors ++ list.errors;
}

nonterminal TypeList with {pp, inputTypes, location, grammarName, env, errors};
concrete production typeListSingle
top::TypeList ::= t::Type
{
  top.pp = t.pp;
  top.location = t.location;
  top.inputTypes = [t.typerep];
  top.errors = t.errors;
}

concrete production typeListCons
top::TypeList ::= t::Type list::TypeList
{
  top.pp = t.pp ++ " " ++ list.pp;
  top.location = t.location;
  top.inputTypes = cons(t.typerep, list.inputTypes);
  top.errors = t.errors ++ list.errors;
}
