grammar silver:extension:convenience;
import silver:base;

concrete production multipleAttributionDcls1
top::AGDcl ::= at::Attribute_kwd a::QNames2 oc::Occurs_kwd o::On_kwd nts::QNames2 s::Semi_t
{
  top.pp = "attribute " ++ a.pp ++ " occurs on " ++ nts.pp ++ " ;" ;
  forwards to makeOccursDcls(at.line, at.column, a.qnames, nts.qnames);
}

concrete production multipleAttributionDcls2
top::AGDcl ::= at::Attribute_kwd a::QName oc::Occurs_kwd o::On_kwd nts::QNames2 s::Semi_t
{
  top.pp = "attribute " ++ a.pp ++ " occurs on " ++ nts.pp ++ " ;" ;
  forwards to makeOccursDcls(at.line, at.column, [a''], nts.qnames);
}

concrete production multipleAttributionDcls3
top::AGDcl ::= at::Attribute_kwd a::QNames2 oc::Occurs_kwd o::On_kwd nts::QName s::Semi_t
{
  top.pp = "attribute " ++ a.pp ++ " occurs on " ++ nts.pp ++ " ;" ;
  forwards to makeOccursDcls(at.line, at.column, a.qnames, [nts'']);
}

--TODO remove this.
concrete production nonterminalWithDcl1
top::AGDcl ::= n::NonTerminal_kwd id::Ids w::With_kwd lc::LCurly_t attrs::QNames rc::RCurly_t s::Semi_t
{
  top.pp = "nonterminal " ++ id.pp ++ " with { " ++ attrs.pp ++ " };";
  forwards to agDclSeq(makeNTDcls(n.line, n.column, id.ids), makeOccursDcls(n.line, n.column, attrs.qnames, qualifyNames(id.ids)));
}

concrete production nonterminalWithDcl2
top::AGDcl ::= n::NonTerminal_kwd id::Ids w::With_kwd attrs::QNames s::Semi_t
{
  top.pp = "nonterminal " ++ id.pp ++ " with { " ++ attrs.pp ++ " };";
  forwards to agDclSeq(makeNTDcls(n.line, n.column, id.ids), makeOccursDcls(n.line, n.column, attrs.qnames, qualifyNames(id.ids)));
}

concrete production nonterminalWithDcl3
top::AGDcl ::= n::NonTerminal_kwd id::Ids2 s::Semi_t  -- w::With_kwd attrs::QNames s::Semi_t
{
  top.pp = "nonterminal " ++ id.pp ++ " ;" ;
  forwards to makeNTDcls(n.line, n.column, id.ids) ;
}
--
concrete production startNonterminalWithDcl1
top::AGDcl ::= st::Start_kwd n::NonTerminal_kwd id::Id_t w::With_kwd lc::LCurly_t attrs::QNames rc::RCurly_t s::Semi_t
{
  top.pp = "start nonterminal " ++ id.lexeme ++ " with { " ++ attrs.pp ++ " };";
  forwards to agDclSeq(startNonterminalDcl(st, n, id, s), makeOccursDcls(st.line, st.column, attrs.qnames, qualifyNames([id])));
}

concrete production startNonterminalWithDcl2
top::AGDcl ::= st::Start_kwd n::NonTerminal_kwd id::Id_t w::With_kwd attrs::QNames s::Semi_t
{
  top.pp = "start nonterminal " ++ id.lexeme ++ " with { " ++ attrs.pp ++ " };";
  forwards to agDclSeq(startNonterminalDcl(st, n, id, s), makeOccursDcls(st.line, st.column, attrs.qnames, qualifyNames([id])));
}

concrete production closedNonterminalWithDcl1
top::AGDcl ::= c::Closed_kwd n::NonTerminal_kwd id::Ids w::With_kwd lc::LCurly_t attrs::QNames rc::RCurly_t s::Semi_t
{
  top.pp = "closed nonterminal " ++ id.pp ++ " with { " ++ attrs.pp ++ " };";
  forwards to agDclSeq(makeClosedNTDcls(c.line, c.column, id.ids), makeOccursDcls(c.line, c.column, attrs.qnames, qualifyNames(id.ids)));
}

concrete production closedNonterminalWithDcl2
top::AGDcl ::= c::Closed_kwd n::NonTerminal_kwd id::Ids w::With_kwd attrs::QNames s::Semi_t
{
  top.pp = "closed nonterminal " ++ id.pp ++ " with { " ++ attrs.pp ++ " };";
  forwards to agDclSeq(makeClosedNTDcls(c.line, c.column, id.ids), makeOccursDcls(c.line, c.column, attrs.qnames, qualifyNames(id.ids)));
}

concrete production attributeDclInhMultiple1
top::AGDcl ::= i::Inherited_kwd at::Attribute_kwd a::Ids2 ht::HasType_t te::Type o1::Occurs_kwd o2::On_kwd qs::QNames s::Semi_t
{
  top.pp = "inherited attribute " ++ a.pp ++ " :: " ++ te.pp ++ " occurs on " ++ qs.pp ++ ";" ;
  forwards to agDclSeq(makeInhDcls(i.line, i.column, te'', a.ids), makeOccursDcls(i.line, i.column, qualifyNames(a.ids), qs.qnames));
}

concrete production attributeDclInhMultiple2
top::AGDcl ::= i::Inherited_kwd at::Attribute_kwd a::Id_t ht::HasType_t te::Type o1::Occurs_kwd o2::On_kwd qs::QNames s::Semi_t
{
  top.pp = "inherited attribute " ++ a.lexeme ++ " :: " ++ te.pp ++ " occurs on " ++ qs.pp ++ ";" ;
  forwards to agDclSeq(makeInhDcls(i.line, i.column, te'', [a]), makeOccursDcls(i.line, i.column, qualifyNames([a]), qs.qnames));
}

concrete production attributeDclSynMultiple1
top::AGDcl ::= sn::Synthesized_kwd  at::Attribute_kwd a::Ids2 ht::HasType_t te::Type o1::Occurs_kwd o2::On_kwd qs::QNames s::Semi_t
{
  top.pp = "synthesized attribute " ++ a.pp ++ " :: " ++ te.pp ++ " occurs on " ++ qs.pp ++ ";" ;
  forwards to agDclSeq(makeSynDcls(sn.line, sn.column, te'', a.ids), makeOccursDcls(sn.line, sn.column, qualifyNames(a.ids), qs.qnames));
}

concrete production attributeDclSynMultiple2
top::AGDcl ::= sn::Synthesized_kwd  at::Attribute_kwd a::Id_t ht::HasType_t te::Type o1::Occurs_kwd o2::On_kwd qs::QNames s::Semi_t
{
  top.pp = "synthesized attribute " ++ a.lexeme ++ " :: " ++ te.pp ++ " occurs on " ++ qs.pp ++ ";" ;
  forwards to agDclSeq(makeSynDcls(sn.line, sn.column, te'', [a]), makeOccursDcls(sn.line, sn.column, qualifyNames([a]), qs.qnames));
}

