grammar silver:extension:fast_string_syntax ;
 export silver:extension:fast_string_syntax ;


import silver:base ;

-- Type Expression --
---------------------

terminal StringAccum_kwd  /StringAccum/ lexer precedence = 15 ;


concrete production stringAccumType
top::Type ::= s::StringAccum_kwd
{
  forwards to  stringType (terminal(String_kwd,"String")) ;
}






-- mkStringAccum
----------------
terminal mkStringAccum_kwd  /mkStringAccum/ lexer precedence = 15 ;

concrete production mkStringAccum_p
top::Expr ::= h::mkStringAccum_kwd lp::LParen_t l::Expr rp::RParen_t 
{ 
  forwards to l'' ;
}


-- mkString
----------------
terminal mkString_kwd  /mkString/ lexer precedence = 15 ;

concrete production mkString_p
top::Expr ::= h::mkString_kwd lp::LParen_t l::Expr rp::RParen_t 
{ 
  forwards to l'' ;
}

-- StringAccum literal --
-------------------------
terminal StringAccum_t /([\@]|[\'])[\"]([^\"\\]|[\\][\"]|[\\][\\]|[\\]n|[\\]r|[\\]t)*[\"]/ lexer precedence = 5;

concrete production stringAccumConst
top::Expr ::= s::StringAccum_t
{
  forwards to stringConst( terminal( String_t,
                                     substring(1,length(s.lexeme),s.lexeme),
                                     s.line, s.column));
}




--  @++  --
-----------

terminal AccumPlusPlus_t /[\@][\+][\+]/  lexer precedence = 6,  precedence = 11, association = left;

concrete production appendStringAccum
top::Expr ::= l::Expr o::AccumPlusPlus_t r::Expr
{ 
 forwards to plusPlus (l , terminal(PlusPlus_t,"++",o.line,o.column), r ) ;
}
