grammar silver:extension:string_accum ;

import silver:base ;
import core;

import silver:translation:ag:haskell ;

-- Type Expression --
---------------------

terminal StringAccum_kwd  /StringAccum/ lexer precedence = 15 ;

-- nonterminal Type with {pp, location, grammarName, typerep, env, errors} ;

concrete production stringAccumType
top::Type ::= s::StringAccum_kwd
{
  top.pp = "StringAccum" ;
  top.typerep = stringAccumTypeRep();
  top.location = "[line: " ++ toString(s.line) ++ ", column: " ++ toString(s.column) ++ "] ";
  top.errors = "";

--  top.parserUses = [];


--  forwards to  stringType (terminal(String_kwd,"String")) ;
}


-- Type Rep --
--------------
--synthesized attribute isStringAccum :: Boolean;
--attribute isStringAccum occurs on TypeRep ;

function stringAccumTypeRep
Decorated TypeRep ::= 
{
  return decorate internal_stringAccumTypeRep() with {};
}

abstract production internal_stringAccumTypeRep
top::TypeRep ::= 
{
  top.type_fullname = "StringAccum";
  top.typeName = "StringAccum";

  top.pp = "StringAccum" ;
  top.isPrimative = true;
  --top.isStringAccum = true;

  top.typeEquals=stringAccumTypeEquals;

  top.haskellType="(String -> String)";

  --top.haskellType="String";

  forwards to internal_defaultTypeRep();



--  forwards to internal_stringTypeRep();
}

--aspect production internal_defaultTypeRep
--top::TypeRep ::= 
--{
--  top.isStringAccum = false;
--}
--
--aspect production internal_topTypeRep
--top::TypeRep ::= 
--{
--  top.isStringAccum = true;
--}

abstract production stringAccumTypeEquals
top::TypeEquals ::= t1::Decorated TypeRep t2::Decorated TypeRep
{
    top.bValue =   t1.typeName == "StringAccum" && t2.typeName == "StringAccum" ;

}
