grammar silver:translation:ag:haskell:core;
import silver:base;
import silver:utils;

aspect production defaultNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.haskell = nonTerminalHaskell(id.lexeme, top.grammarName, top.globalEnv);
}

aspect production defaultClosedNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.haskell = nonTerminalHaskell(id.lexeme, top.grammarName, top.globalEnv);
}

aspect production closeNonterminalDcl
top::AGDcl ::= c::Close_kwd q::QName  s::Semi_t
{
  top.haskell = @"";
}

aspect production defaultStartNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.haskell = nonTerminalHaskell(id.lexeme, top.grammarName, top.globalEnv);
}

function nonTerminalHaskell
StringAccum ::= n::String pn::Decorated QName e::Decorated Env
{
  local attribute hn :: String;
  hn = "NT_" ++ makeName(pn.name) ++ "_" ++ n;

  local attribute hnA :: StringAccum;
  hnA = @"NT_" ++ mkStringAccum(makeName(pn.name)) ++ @"_" ++ mkStringAccum(n);

  local attribute fqn :: String;
  fqn = pn.name ++ ":" ++ n;

  local attribute decorating :: [Decorated EnvItem];
  decorating = getAllOccuringOn(fqn, e);

  local attribute syns :: [Decorated EnvItem];
  syns = filterEnvItems(keepSyns(e), decorating);

  local attribute inhs :: [Decorated EnvItem];
  inhs = filterEnvItems(keepInhs(e), decorating);
 
--  local attribute string_syns :: String;
--  string_syns = getAttrStr("attr_" ++ (hn), ",\n  ", syns);
--
--  local attribute string_inhs :: String;
--  string_inhs = getAttrStr("attr_" ++ (hn), ",\n  ", inhs);

  local attribute string_syns :: StringAccum;
  string_syns = mkStringAccum(getAttrStr("attr_" ++ (hn), ",\n  ", syns));

  local attribute string_inhs :: StringAccum;
  string_inhs = mkStringAccum(getAttrStr("attr_" ++ (hn), ",\n  ", inhs));
  
--  local attribute node_def :: String;
--  node_def = "data " ++ hn ++ " = " ++ hn ++ 
--        " {\n new_" ++ hn ++ " :: INHS_" ++ hn ++ " -> " ++ hn ++ ",\n" ++
--           " syns_" ++ hn ++ " :: SYNS_" ++ hn ++ ",\n" ++
--           " inhs_" ++ hn ++ " :: INHS_" ++ hn ++ "\n}\n";

  local attribute node_defA :: StringAccum;
  node_defA = @"data " ++ hnA ++ @" = " ++ hnA ++ node_defA2 ;

  local attribute node_defA2 :: StringAccum;
  node_defA2 = 
        @" {\n new_" @++ hnA @++ @" :: INHS_" @++ hnA @++ @" -> " @++ hnA @++ @",\n" @++
           @" syns_" @++ hnA @++ @" :: SYNS_" @++ hnA @++ @",\n" @++
           @" inhs_" @++ hnA @++ @" :: INHS_" @++ hnA @++ @"\n}\n";



--  local attribute node_defA2 :: StringAccum;
--  node_defA2 = 
--        @" {\n new_" ++ hnA ++ @" :: INHS_" ++ hnA ++ @" -> " ++ hnA ++ @",\n" ++
--           @" syns_" ++ hnA ++ @" :: SYNS_" ++ hnA ++ @",\n" ++
--           @" inhs_" ++ hnA ++ @" :: INHS_" ++ hnA ++ @"\n}\n";

  local attribute syns_def :: StringAccum;
  syns_def = @"data SYNS_" ++ hnA ++ @" = SYNS_" ++ hnA ++ @" {\n  " ++ (string_syns) ++ @"\n}\n";

  local attribute inhs_def :: StringAccum;
  inhs_def = @"data INHS_" ++ hnA ++ @" = INHS_" ++ hnA ++ @" {\n  " ++ (string_inhs) ++ @"\n}\n";

  return node_defA ++ syns_def ++ inhs_def;

--  local attribute syns_def :: String;
--  syns_def = "data SYNS_" ++ hn ++ " = SYNS_" ++ hn ++ " {\n  " ++ (string_syns) ++ "\n}\n";

--  local attribute inhs_def :: String;
--  inhs_def = "data INHS_" ++ hn ++ " = INHS_" ++ hn ++ " {\n  " ++ (string_inhs) ++ "\n}\n";

--  return node_defA ++ mkStringAccum(syns_def ++ inhs_def);
}


--function nonTerminalHaskell
--StringAccum ::= n::String pn::Decorated QName e::Decorated Env
--{
--  local attribute hn :: StringAccum;
--  hn = @"NT_" ++ mkStringAccum(makeName(pn.name)) ++ @"_" ++ mkStringAccum(n);
--
--  local attribute fqn :: String;
--  fqn = pn.name ++ ":" ++ n;
--
--  local attribute decorating :: [Decorated EnvItem];
--  decorating = getAllOccuringOn(fqn, e);
--
--  local attribute syns :: [Decorated EnvItem];
--  syns = filterEnvItems(keepSyns(e), decorating);
--
--  local attribute inhs :: [Decorated EnvItem];
--  inhs = filterEnvItems(keepInhs(e), decorating);
-- 
--  local attribute string_syns :: String;
--  string_syns = getAttrStr("attr_" ++ hn, ",\n  ", syns);
--
--  local attribute string_inhs :: String;
--  string_inhs = getAttrStr("attr_" ++ hn, ",\n  ", inhs);
--  
--  local attribute node_def :: StringAccum;
--  node_def = @"data " ++ hn ++ @" = " ++ hn ++ 
--        @" {\n new_" ++ hn ++ @" :: INHS_" ++ hn ++ @" -> " ++ hn ++ @",\n" ++
--           @" syns_" ++ hn ++ @" :: SYNS_" ++ hn ++ @",\n" ++
--           @" inhs_" ++ hn ++ @" :: INHS_" ++ hn ++ @"\n}\n";
--
--  local attribute syns_def :: StringAccum;
--  syns_def = @"data SYNS_" ++ hn ++ @" = SYNS_" ++ hn ++ @" {\n  " ++ mkStringAccum(string_syns) ++ @"\n}\n";
--
--  local attribute inhs_def :: StringAccum;
--  inhs_def = @"data INHS_" ++ hn ++ @" = INHS_" ++ hn ++ @" {\n  " ++ mkStringAccum(string_inhs) ++ @"\n}\n";
--
--  return node_def ++ syns_def ++ inhs_def;
--}
--
abstract production keepInhs
top::EnvFilter ::= e::Decorated Env
{
  top.keep = isInherited(top.inEnvItem.itemName, e);
}

abstract production keepSyns
top::EnvFilter ::= e::Decorated Env
{
  top.keep = isSynthesized(top.inEnvItem.itemName, e);
}

function getAttrStr
String ::= pref::String sep::String atts::[Decorated EnvItem]
{  
  local attribute fn :: String;
  fn = makeName(head(atts).itemName);

  return if null(atts)
	 then ""
	 else pref ++ "__" ++ (fn) ++ " :: " ++ (head(atts).typerep.haskellType)
 	      ++ (if length(tail(atts)) == 0 then "" else sep )
	      ++ getAttrStr(pref, sep, tail(atts));
}
--
--function getAttrStr
--StringAccum ::= pref::StringAccum sep::StringAccum atts::[Decorated EnvItem]
--{  
--  local attribute fn :: StringAccum;
--  fn = mkStringAccum(makeName(head(atts).itemName));
--
--  return if null(atts)
--	 then @""
--	 else pref ++ @"__" ++ fn ++ @" :: " ++ mkStringAccum(head(atts).typerep.haskellType)
-- 	      ++ (if length(tail(atts)) == 0 then @"" else sep )
--	      ++ getAttrStr(pref, sep, tail(atts));
--}
--
