grammar silver:translation:ag:haskell:core;
import silver:base;
import silver:utils;

synthesized attribute haskellType :: String;
attribute haskellType occurs on TypeRep;

aspect production internal_integerTypeRep
top::TypeRep ::= 
{
  top.haskellType = "Int";
}

aspect production internal_floatTypeRep
top::TypeRep ::= 
{
  top.haskellType = "Float";
}

aspect production internal_stringTypeRep
top::TypeRep ::= 
{
  top.haskellType = "String";

}

aspect production internal_booleanTypeRep
top::TypeRep ::= 
{
  top.haskellType = "Bool";

}

aspect production internal_termTypeRep
top::TypeRep ::= n::String
{
  top.haskellType = "TERMINAL";

}

aspect production internal_ntTypeRep
top::TypeRep ::= n::String
{
  top.haskellType = "INHS_NT_" ++ makeName(n) ++ " -> NT_" ++ makeName(n);
}

aspect production internal_refTypeRep
top::TypeRep ::= t::Decorated TypeRep
{
  top.haskellType = "NT_" ++ makeName(t.typeName);

}

aspect production internal_prodTypeRep
top::TypeRep ::= it::[Decorated TypeRep] ot::Decorated TypeRep
{
  top.haskellType = makeTypeRepListHaskell(it) ++ ot.haskellType;
}

aspect production internal_topTypeRep
top::TypeRep ::= 
{
  top.haskellType = "TOP";

}

function makeTypeRepListHaskell
String ::= l::[Decorated TypeRep]
{
  return if null(l)
	 then ""
	 else "(" ++ head(l).haskellType ++ ")" ++ " -> " ++ makeTypeRepListHaskell(tail(l));
}


aspect production internal_ioTypeRep
top::TypeRep ::= 
{
  top.haskellType = "IO Int";
}

aspect production internal_defaultTypeRep
top::TypeRep ::= 
{
  top.haskellType = "Int";
}
