grammar silver:translation:ag:haskell:type:io;

import silver:base;
-- import silver:translation:haskell:core;

import silver:translation:ag:haskell:core;

aspect production isFileFunction
top::Expr ::= i::IsFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  local attribute task :: StringAccum;
  task = @"return (production_core_ioBoolean ( return (t + 1) ) (unsafePerformIO (doesFileExist " ++ e1.haskell ++ @")) )";

  top.haskell = @"(unsafePerformIO ( " ++ e2.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" ))";
}

aspect production isDirectoryFunction
top::Expr ::= i::IsDirectory_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  local attribute task :: StringAccum;
  task = @"return (production_core_ioBoolean ( return (t + 1) ) (unsafePerformIO (doesDirectoryExist " ++ e1.haskell ++ @")) )";

  top.haskell = @"(unsafePerformIO ( " ++ e2.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" ))";
}

--(openFile "Project.sv" ReadMode) >>= \hdl -> (hGetContents hdl) >>= \str -> (putStrLn str) >>= \_ -> (hClose hdl) >>= \_ ->  (return (True, str)) >>= \_ -> (putStrLn str);
aspect production readFunction
top::Expr ::= r::ReadFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr rp::RParen_t
{
  local attribute task :: StringAccum;
  task = @"((readFile " ++ e1.haskell ++ @") >>= \\str ->  (return (production_core_ioString ( return (t + 1) ) str )))";
--  task = "((openFile " ++ e1.haskell ++ " ReadMode) >>= \\hdl -> (getContents hdl) >>= \str -> (hClose hdl) >>= \\_ ->  (return (production_core_ioString ( return True ) str )))";

  top.haskell = @"(unsafePerformIO ( " ++ e2.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" ))";
}

aspect production cwdFunction
top::Expr ::= c::CWD_kwd l::LParen_t e::Expr r::RParen_t
{
  local attribute task :: StringAccum;
  task = @"return (production_core_ioString ( return (t + 1) ) (unsafePerformIO ( getCurrentDirectory )))";

  top.haskell = @"(unsafePerformIO ( " ++ e.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" ))";
}

aspect production envVarFunction
top::Expr ::= e::EnvVar_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  local attribute task :: StringAccum;
  task = @"return (production_core_ioString (return (t + 1)) (unsafePerformIO ((System.getEnv " ++ e1.haskell ++ @" ) `catch` (\\e -> return \"\")) ))";

  top.haskell = @"(unsafePerformIO ( " ++ e2.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" ))";
}

aspect production systemFunction
top::Expr ::= s::System_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  local attribute task :: StringAccum;
  task = @"((System.system " ++ e1.haskell ++ @") " ++
	 @">>= \\out ->  return (case out of { ExitSuccess -> 0; ExitFailure i -> -1}) " ++
	 @">>= \\code -> return (production_core_ioInteger (return (t + 1)) code ))";

  top.haskell = @"(unsafePerformIO ( " ++ e2.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" ))";
}

aspect production writeFunction
top::Expr ::= w::WriteFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{  
  local attribute task :: StringAccum;
  task = @"((writeFile " ++ e1.haskell ++ @" " ++ e2.haskell ++ @") >>= \\_ -> (return (t + 1) ))";

  top.haskell = @"( " ++ e3.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" )";
}

aspect production appendFunction
top::Expr ::= a::AppendFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{
  local attribute task :: StringAccum;
  task = @"((appendFile " ++ e1.haskell ++ @" " ++ e2.haskell ++ @") >>= \\_ -> (return (t + 1) ))";

  top.haskell = @"( " ++ e3.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" )";
}

aspect production printFunction
top::Expr ::= p::Print_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  local attribute task :: StringAccum;
  task = @"((putStr " ++ e1.haskell ++ @") >>= \\_ -> (return (t + 1) ))";

  top.haskell = @"( " ++ e2.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" )";
}

aspect production listContentsFunction
top::Expr ::= li::ListContents_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  local attribute task::StringAccum;
  task = @"( " ++
	        @"(getDirectoryContents " ++ e1.haskell ++ @") " ++
		@">>= (\\strlist -> return (production_core_ioStringList " ++
			                  @"(return (t + 1)) " ++ 
				          @"(foldl (\\l str ->  production_core_cons_string str l ) (production_core_empty_string) strlist)" ++
				         @")" ++ 
		    @")" ++ 
         @")";

  top.haskell = @"(unsafePerformIO ( " ++ e2.haskell ++ @">>= \\t -> if t > 0 then " ++  task ++ @" else " ++ task ++ @" ))";
}

aspect production unsafeIOFunction
top::Expr ::= u::UnsafeIO_kwd
{  
  top.haskell = @"(return 1)";
}

aspect production genIntFunction
top::Expr ::= g::GenInt_kwd l::LParen_t r::RParen_t
{
  top.haskell = @"(genint () )";
}
