grammar silver:translation:c:type:anytype;
import silver:translation:c:core;
import silver:base;

import silver:utils;


--TODO fix the type_fullname attribute
synthesized attribute type_fullname :: String ;
attribute type_fullname occurs on TypeRep ;


aspect production internal_anyTypeTypeRep
top::TypeRep ::= 
{
  top.type_fullname = "AnyType";
  top.haskellType = "Haskell_AnyType" ;
}

-- Type Rep aspects
-------------------
aspect production internal_integerTypeRep
top::TypeRep ::= 
{
  top.type_fullname = top.typeName ;
}

aspect production internal_floatTypeRep
top::TypeRep ::= 
{
  top.type_fullname = top.typeName ;
}

aspect production internal_stringTypeRep
top::TypeRep ::= 
{
  top.type_fullname = top.typeName ;
}

aspect production internal_booleanTypeRep
top::TypeRep ::= 
{
  top.type_fullname = top.typeName ;
}

aspect production internal_termTypeRep
top::TypeRep ::= n::String
{
  top.type_fullname = "Terminal__" ++ makeName(n) ;
}

aspect production internal_ntTypeRep
top::TypeRep ::= n::String
{
  top.type_fullname = "NT__" ++ makeName(n) ;
}

aspect production internal_refTypeRep
top::TypeRep ::= t::Decorated TypeRep
{
  top.type_fullname = "Ref__" ++ t.type_fullname ;
}

aspect production internal_prodTypeRep
top::TypeRep ::= it::[Decorated TypeRep] ot::Decorated TypeRep
{
  top.type_fullname = "Prod__" ++ makeTrlFullNames(it) ++ "__TO__" ++ ot.type_fullname ;
}

aspect production internal_topTypeRep
top::TypeRep ::= 
{
  top.type_fullname = "TOP";
}

aspect production internal_ioTypeRep
top::TypeRep ::= 
{
  top.type_fullname = "IO";
}

aspect production internal_defaultTypeRep
top::TypeRep ::= 
{
  top.type_fullname = "DEFAULT";
}
function makeTrlFullNames
String ::= l::[Decorated TypeRep]
{
  return if null(l) then "" else  head(l).type_fullname ++ "__" ++ makeTrlFullNames(tail(l));
}