grammar silver:translation:haskellc:core;
import silver:base hiding grammarName;
import silver:utils:command;
import silver:utils;
import silver:translation:ag:haskell ;

import core;

--function stringPP
--String ::= s1::String s2::String
--{
--  return s1 ++ s2;
--}

aspect production run
top::RunUnit ::= iIn::IO args::String p::Production(Root ::= String)
{
  postOps <- [genHaskell(a'', grammars)]; 
}

--abstract production genHaskell
--top::Unit ::= a::Command specs::[GrammarSpec]
--{
--  forwards to genHaskellHelp(a'', specs)
--	with {
--		ioIn = print("Generating Haskell Translation.\n", top.ioIn);
--	};
--}
--
--function mergeParsers
--[String] ::= l::[GrammarSpec]
--{
--  return if null(l) then [] else head(l).rootSpec.parserUses ++ mergeParsers(tail(l));
--}

aspect production genHaskellHelp
top::Unit ::= a::Command specs::[GrammarSpec]
{
--  local attribute term :: String;
--  term = "module Terminal where\n" ++
--   	 "data TERMINAL = TERMINAL { syns_TERMINAL :: SYNS_TERMINAL}\n" ++
--	 "data SYNS_TERMINAL = SYNS_TERMINAL { attr_TERMINAL__lexeme :: String, " ++ 
--					      "attr_TERMINAL__line :: Int, " ++ 
--					      "attr_TERMINAL__column :: Int }\n\n" ++
-- 	 "instance Show TERMINAL where\n" ++
--         "  show t = \"[Line: \" ++ (show (attr_TERMINAL__line (syns_TERMINAL t))) ++ " ++
--              "\"] [Column: \" ++ (show (attr_TERMINAL__column (syns_TERMINAL t))) ++ " ++
--              "\"] [Token: \" ++ (attr_TERMINAL__lexeme (syns_TERMINAL t)) ++ \"]\"\n\n";
--
--  local attribute hn :: String;
--  hn = makeName(a.grammarName);
--
--  local attribute pUses :: [String];
--  pUses = mergeParsers(specs);
--
--  local attribute mod_boot :: String;
--  mod_boot = "module Module_" ++ hn ++ " where\n" ++ buildModuleBootSpec(buildStartSet(specs));
--
----  production attribute globalHaskell :: String with stringPP;
----  globalHaskell := "";
--
--  local attribute header :: String;
--  header = "module Module_" ++ hn ++ " where\n" ++
--           "import Terminal\nimport System.IO.Unsafe\nimport Directory\nimport List\nimport System\nimport Data.IORef\nimport Char\n" ++ 
--            buildImportString(specs, pUses) ++ 
--	   "idnum_counter :: IORef Int\n"++
--	   "idnum_counter = unsafePerformIO (newIORef (0::Int))\n\n" ++
--	   "genint :: () -> Int\n" ++
--	   "genint () = unsafePerformIO\n" ++ 
--	   "                 ( do\n" ++
--	   "                    y <- readIORef idnum_counter\n" ++
--	   "                    writeIORef idnum_counter (y + 1)\n" ++ 
--	   "                    return y\n" ++                    
--	   "                 )\n\n"  ++
--           globalHaskell  ++ "\n\n"
--           ;
--
  local attribute i0 :: IO;
  i0 = writeFile(a.generatedPath ++ "Terminal.hs", term, top.ioIn);

  local attribute i1 :: IO;
  i1 = writeFile(a.generatedPath ++ "Module_" ++ hn ++ ".hs-boot", mod_boot, i0);

  local attribute i2 :: IO;
  i2 = writeFile(a.generatedPath ++ "Module_" ++ hn ++ ".hs", header, i1);

  local attribute i3 :: IO;
  i3 = writeAll(i2, a, specs, pUses);

  local attribute i4 :: IO;
  i4 = writeMainHS(i3, a);
    
  local attribute c :: IOString;
  c = cwd(i4);

  local attribute cc :: IOString;
  cc = buildCCString(specs, a'', c.io, pUses);

  local attribute ghc_compile_str :: String;
  ghc_compile_str = 
		    "echo \"ghc -c Terminal.hs\"\n" ++ 
		    "ghc  -c Terminal.hs\n" ++ 
		    "echo \"ghc -c Module_" ++ hn ++ ".hs-boot\"\n" ++
		    "ghc  -c Module_" ++ hn ++ ".hs-boot\n" ++
                     buildGHCBootString(specs, pUses) ++ 
		    "echo \"ghc -c Module_" ++ hn ++ ".hs\"\n" ++
		    "ghc  -c Module_" ++ hn ++ ".hs\n" ++
                     cc.sValue ++ 
                     buildParserString(specs, pUses) ++ 
		    "echo \"ghc -c Main.hs\"\n" ++
		    "ghc  -c Main.hs\n" ++
		    "echo \"ghc -o " ++ c.sValue ++ "/" ++ a.outName ++ " Main.o Terminal.o Module_" ++ hn ++ ".o " ++ buildLinkString(specs, pUses) ++ "\"\n" ++
		    "ghc -o " ++ c.sValue ++ "/" ++ a.outName ++ " Main.o Terminal.o Module_" ++ hn ++ ".o " ++ buildLinkString(specs, pUses) ++ "\n";

  local attribute i5 :: IO;
  i5 = writeFile(a.generatedPath ++ "ghc-compile", ghc_compile_str, cc.io);

  --top.io = system("pushd " ++ a.generatedPath ++ ">> /dev/null; chmod +x ./ghc-compile; ./ghc-compile; popd >> /dev/null", i5).io;
  top.io = if a.noGHCCompile 
           then -- i5 
                system("pushd " ++ a.generatedPath ++ ">> /dev/null; chmod +x ./ghc-compile;                popd >> /dev/null", i5).io
           else system("pushd " ++ a.generatedPath ++ ">> /dev/null; chmod +x ./ghc-compile; ./ghc-compile; popd >> /dev/null", i5).io;

  top.code = 0;
  top.order = 3;
}

function buildLinkString
String ::= cl::[GrammarSpec] s::[String]
{
  local attribute n :: String;
  n = "Module_" ++ makeName(head(cl).name);

  return if null(cl) 
	 then ""
	 else if head(cl).rootSpec.hasStartSymbol && containsString(head(cl).name ++ ":parse", s)
	      then n ++ "_Parser.o " ++ buildLinkString(tail(cl), s)
	      else buildLinkString(tail(cl), s);
}

function buildCCString
IOString ::= cl::[GrammarSpec] a::Command i::IO s::[String]
{
  local attribute envArg :: IOString;
  envArg = envVar("GRAMMAR_PATH", i);

  local attribute sPath :: String;
  sPath = a.searchPath ++ ":" ++ envArg.sValue;

  local attribute spath :: [String];
  spath = getSearchPath(sPath);

  --the grammar path ':' replaced by '/'
  local attribute gpath :: String;
  gpath = getGrammarPath(head(cl).name) ++ "/";

  local attribute gloc :: MaybeIOStr;
  gloc = findGrammarLocation(envArg.io, gpath, spath);
  
  local attribute i2 :: IO;
  i2 = system("mkdir -p " ++ gloc.sValue ++ "/.parsers/`arch`", gloc.io).io;

  local attribute n :: String;
  n = "Module_" ++ makeName(head(cl).name);

  local attribute c :: IOString;
  c = cwd(i2);

  local attribute out :: String;
  out = (if substring(0, 1, gloc.sValue) == "/" then "" else c.sValue ++ "/") ++ gloc.sValue ++ "/.parsers/`arch`/" ++ makeName(head(cl).name) ++ "_parser";

  local attribute recurse1 :: IOString;
  recurse1 = buildCCString(tail(cl), a'', c.io, s);

  local attribute recurse2 :: IOString;
  recurse2 = buildCCString(tail(cl), a'', gloc.io, s);

  return if null(cl)
	 then ioString(i, "") 
	 else if head(cl).rootSpec.hasStartSymbol && containsString(head(cl).name ++ ":parse", s)
	      then if gloc.found
		   then ioString(recurse1.io, "echo \"gcc -o " ++ out ++ " " ++ n ++ "_Parser.c " ++ n ++ "_Scanner.c\"\n" ++ 
 		   	                      "gcc -o " ++ out ++ " " ++ n ++ "_Parser.c " ++ n ++ "_Scanner.c\n" ++ 
				  	      recurse1.sValue)
		   else error("You Should Not Get Here.")
	      else recurse2'';
}

--function buildGHCBootString
--String ::= cl::[GrammarSpec] s::[String]
--{
--  local attribute n :: String;
--  n = "Module_" ++ makeName(head(cl).name);
--
--  return if null(cl)
--	 then "" 
--	 else if head(cl).rootSpec.hasStartSymbol && containsString(head(cl).name ++ ":parse", s)
--	      then 
--		   "echo \"ghc -c " ++ n ++ "_Parser.hs-boot\"\n" ++ 
--		   "ghc -c " ++ n ++ "_Parser.hs-boot\n" ++ buildGHCBootString(tail(cl), s)
--	      else "\n" ++ buildGHCBootString(tail(cl), s);
--}
--
--function buildImportString
--String ::= cl::[GrammarSpec] s::[String]
--{
--  local attribute n :: String;
--  n = "Module_" ++ makeName(head(cl).name);
--
--  return if null(cl)
--	 then "" 
--	 else if head(cl).rootSpec.hasStartSymbol && containsString(head(cl).name ++ ":parse", s)
--	      then "import {-# SOURCE #-} " ++ n ++ "_Parser\n" ++ buildImportString(tail(cl), s)
--	      else "\n" ++ buildImportString(tail(cl), s);
--}
--
--function buildParserString
--String ::= cl::[GrammarSpec] s::[String]
--{
--  local attribute n :: String;
--  n = "Module_" ++ makeName(head(cl).name);
--
--  return if null(cl)
--	 then "" 
--	 else if head(cl).rootSpec.hasStartSymbol && containsString(head(cl).name ++ ":parse", s)
--	      then 
--		   "echo \"ghc -c " ++ n ++ "_Parser.hs\"\n" ++ 
--		   "ghc -c " ++ n ++ "_Parser.hs\n" ++ buildParserString(tail(cl), s)
--	      else "\n" ++ buildParserString(tail(cl), s);
--}
--
--function buildStartSet
--[String] ::= cl::[GrammarSpec]
--{
--  local attribute spec :: Decorated RootSpec;
--  spec = head(cl).rootSpec;
--
--  local attribute has_start :: Boolean;
--  has_start = spec.hasStartSymbol;
--
--  local attribute shn :: String;
--  shn = "NT_" ++ makeName(spec.startName);
--
--  local attribute rest :: [String];
--  rest = buildStartSet(tail(cl));
--
--  return if null(cl) 
--	 then []
--	 else if has_start && !containsString(shn, rest)
--	      then cons(shn, rest)
--	      else rest;
--}
--
--function buildModuleBootSpec
--String ::= sl::[String]
--{
--  return if null(sl) then "\n"
--         else "data " ++ head(sl) ++ "\n" ++ "data INHS_" ++ head(sl) ++ "\n" ++ buildModuleBootSpec(tail(sl));
--}
--

--function writeMainHS
--IO ::= i::IO a::Decorated Command
--{
--  local attribute hname :: String;
--  hname = makeName(a.grammarName);
--
--  local attribute b :: String;
--  b = "module Main where\n" ++
--	 "import System\n" ++
--	 "import Module_" ++ hname ++ "\n" ++ 
--	 "main = do\n" ++ 
--	 "args <- System.getArgs\n" ++
--         "arg  <- return (if (length args) == 0 then \"\" else (tail (foldl (\\old new -> old ++ \" \" ++ new) \"\" args)))\n" ++ 
--         "inhs <- return (INHS_NT_core_Main {\n" ++
--	 "		   attr_NT_core_Main__core_ioIn = (return True)\n" ++
--	 "	          })\n" ++
----         (if accum()
----          then 
-----------------           "syns <- return (syns_NT_core_Main  (production_" ++ hname ++ "_main (arg ++) inhs))\n" 
----          else "syns <- return (syns_NT_core_Main  (production_" ++ hname ++ "_main arg inhs))\n"
----         ) 
--         "syns <- return (syns_NT_core_Main  (production_" ++ hname ++ "_main arg inhs))\n" ++
--         "( attr_NT_core_Main__core_ioOut syns )\n";
--
--  return writeFile(a.generatedPath ++ "Main.hs", b, i);
--}
--
--
--
--function writeAll
--IO ::= i::IO a::Decorated Command l::[GrammarSpec] s::[String]
--{
--  local attribute now :: IO;
--  now = writeSpec(i, head(l).name, head(l).rootSpec, a, s);
--
--  local attribute recurse :: IO;
--  recurse = writeAll(now, a, tail(l), s);
--
--  return if null(l) then i else recurse;
--}
--
--
--function writeSpec
--IO ::= i::IO gName::String r::Decorated RootSpec a::Decorated Command s::[String]
--{
--  local attribute thn :: String;
--  thn = makeName(a.grammarName);
--
--  -- the haskell name of the grammar.
--  local attribute hn :: String;
--  hn = makeName(gName);
--  
--  local attribute has_start :: Boolean;
--  has_start = r.hasStartSymbol && containsString(gName ++ ":parse", s);
--
--  local attribute header :: String;
--  header = if has_start then "production_" ++ hn ++ "_parse str = Module_" ++ hn ++ "_Parser.doparse str " else "\n";
--
--  return appendFile(a.generatedPath ++ "Module_" ++ thn ++ ".hs", header ++ "\n" ++ r.haskell, i);
--}
--
