grammar silver:translation:haskellc:lexyacc;
import silver:base;
import silver:utils;


synthesized attribute lexSpec :: String;
synthesized attribute lexTokenSpec :: String ;

function makeLexSpec
String ::= gn::String spec::Decorated RootSpec
{
  local attribute filtered :: FilterResult;
  filtered = filterSyntax(spec.hiddenSyntax, spec.terminalDcls, spec.ruleDcls);

  return 
	"%{\n" ++
	"#include \"Module_" ++ makeName(gn) ++ "_Parser.h\"\n" ++
	"char * cpy (char * t);\n" ++ 
	"void updateColumn ();\n" ++ 	
	"int yycolumn = 1;\n" ++ 
	"%}\n" ++ 
	"%option noyywrap\n" ++
	"%option yylineno\n" ++
	"%pointer\n" ++
	"%%\n\n" ++
        makeLexSpecString(tsMergeSort(filtered.terminalDcls)) ++ "\n\n" ++
	"%%\n\n" ++

	"int main_lex(int argc, char *argv[])\n" ++
	"{\n" ++
	"  yyin = stdin;\n" ++
	"  while (yylex() != 0);\n" ++
	"}\n\n" ++

	"void updateColumn(){\n" ++
	"  int i = 0;\n" ++
	"  for(i; i < sizeof(yytext); i++){\n" ++
	"        if(yytext[i] == '\\0'){\n" ++
	"                i = sizeof(yytext);\n" ++
	"        }else if(yytext[i] == '\\n'){\n" ++
	"                yycolumn = 0;\n" ++
	"        }else{\n" ++
	"                yycolumn++;\n" ++
	"        }\n" ++
	"  }\n" ++
	"}\n";
}

function makeLexSpecString
String ::= specs::[TerminalSpec]
{
  return if null(specs)
	 then ""
	 else substring(1, length(head(specs).terminalRegExpr) -1, head(specs).terminalRegExpr) 
              --head(specs).terminalRegExpr
              ++ 
	      (if head(specs).ignoreTerminal
	       then " { updateColumn(); } \n"
	       else " {\n\t" ++
		      "char buffer [100];\n\t" ++ 
                      "struct terminal t;\n\n\t" ++

                      "t.lexeme = cpy(yytext);\n\n\t" ++

		      "sprintf (buffer, \"%d\" ,yylineno);\n\t" ++
                      "t.line = cpy(buffer);\n\n\t" ++

		      "sprintf (buffer, \"%d\" ,yycolumn);\n\t" ++
                      "t.column = cpy(buffer);\n\n\t" ++

                      "yylval.term = t;\n\n\t" ++

                      "updateColumn();\n\n\t" ++
			
	              "return " ++ makeName(head(specs).terminalName) ++ ";\n}\n"
              ) 

              ++ makeLexSpecString(tail(specs));
}
