grammar silver:translation:haskelljava:concretesyntax;
import core only bValue;

import silver:base:cs:default;
import silver:base:core;
import silver:analysis:typechecking;
import silver:base:type:io only Print_kwd;

import silver:extension:list ;

terminal Pluck_kwd /pluck/ lexer precedence = 10; 

concrete production pluckDef
top::ProductionStmt ::= c1::Pluck_kwd c3::Expr c4::Semi_t
{
  top.pp = "pluck " ++ c3.pp ++ ";\n";
  top.location = "[line: " ++ toString(c1.line) ++ ", column: " ++ toString(c1.column) ++ "] ";
  -- FIXME
  top.hasValidActionCode = c3.hasValidActionCode;
  top.actionCode = if top.actionCodeType.isDisambigGroupAction
                   then (actionCodeConcat(actionCodeCode("return "),
                         actionCodeConcat(c3.actionCode,actionCodeCode(";\n"))))
                   else actionCodeError(top.location ++ " Error: Construct 'pluckDef' allowed only in disambiguation-group parser actions\n");

  top.defs = emptyDefs();

  top.prodDefs = emptyDefs();

  top.errors = if top.actionCodeType.isSemanticBlock
               then top.location ++ " Error: Construct 'pluckDef' allowed only in disambiguation-group parser actions\n"
               else "";

  top.typeErrors = "";

  top.stmtList = [];
}

concrete production printStmt
top::ProductionStmt ::= p::Print_kwd c3::Expr c4::Semi_t
{
  top.pp = "print " ++ c3.pp ++ ";\n";
  top.location = "[line: " ++ toString(p.line) ++ ", column: " ++ toString(p.column) ++ "] ";

  top.hasValidActionCode = c3.hasValidActionCode;
  top.actionCode = if c3.typerep.typeName == "String"
                   then (actionCodeConcat(actionCodeCode("System.err.println("),
                          actionCodeConcat(c3.actionCode,actionCodeCode(");\n"))))
                   else actionCodeError(top.location ++ " Error: Parameter to 'print' must be of type String\n");

  top.defs = emptyDefs();

  top.prodDefs = emptyDefs();

  top.errors = if top.actionCodeType.isSemanticBlock
               then top.location ++ " Error: Construct 'printStmt' allowed only in parser actions\n"
               else "";
  top.typeErrors = "";

  top.stmtList = [];
}

terminal ListContains_kwd /listContains/ lexer precedence = 10;

concrete production listContainsExpr
top::Expr ::= lc::ListContains_kwd lp::LParen_t e1::Expr c::Comma_t e2::Expr rp::RParen_t 
{
  top.pp = "listContains( " ++ e1.pp ++ ","  ++ e2.pp ++ " )";
  top.location = "[line: " ++ toString(lc.line) ++ ", column: " ++ toString(lc.column) ++ "] ";

  top.hasValidActionCode = e1.hasValidActionCode && e2.hasValidActionCode &&
                           e2.typerep.isList &&
                           e2.typerep.listComponent.typeEquals(e2.typerep.listComponent,e1.typerep).bValue;
  top.actionCode = if !e2.typerep.isList
                   then actionCodeError(top.location ++ " Error: Second argument to 'listContains' must be a list, is '" ++ e2.typerep.typeName ++ "\n")
                   else if !e2.typerep.listComponent.typeEquals(e2.typerep.listComponent,e1.typerep).bValue
                        then actionCodeError(top.location ++ " Error: Type of element and list must be the same, are '" ++ e1.typerep.typeName ++ "' and '" ++ e2.typerep.listComponent.typeName ++ "'\n")
                        else actionCodeConcat(actionCodeCode("listContains ( "),
                              actionCodeConcat(e1.actionCode,
                               actionCodeConcat(actionCodeCode(", "),
                                actionCodeConcat(e2.actionCode,
                                 actionCodeCode(" ) ")))));

  top.typerep = booleanTypeRep();

  top.errors = if top.actionCodeType.isSemanticBlock
               then top.location ++ " Error: Construct 'listContainsExpr' allowed only in parser actions\n"
               else "";
  top.typeErrors = "";
}
