grammar silver:translation:haskelljava:concretesyntax;
import silver:base:cs:default;
import silver:base:core;

import silver:translation:haskelljava:core;

import silver:analysis:typechecking:core;
import silver:extension:easyterminal;

synthesized attribute isDisambiguationGroupDeclaration :: Boolean;
synthesized attribute disambiguationGroupDeclaration :: DisambiguationGroupSpec;

attribute isDisambiguationGroupDeclaration occurs on EnvItem;

-- This adds  disambiguation_group n  entries
function addDisambiguationGroupDcl
Decorated Defs ::= n::String e::Decorated Defs
{
  return consDefs(disambiguationGroupEnvItem(n), e);
}

function disambiguationGroupEnvItem
Decorated EnvItem ::= n::String
{
  return decorate internal_disambiguationGroupEnvItem(n) with {};
}
abstract production internal_disambiguationGroupEnvItem
top::EnvItem ::= n::String
{
  -- required to be defined.
  top.itemName = n;
  top.pp = "disambiguation_group " ++ n ;

  top.isDisambiguationGroupDeclaration = true;

  forwards to internal_defaultEnvItem();
}

synthesized attribute groupName :: String;
synthesized attribute groupMembers :: [String];

nonterminal DisambiguationGroupSpec with {groupName,groupMembers,actionCode};

abstract production disambiguationGroupSpec
top::DisambiguationGroupSpec ::= gName::String members::[String] acode::ActionCode
{
   top.groupName = gName;
   top.groupMembers = members;
   top.actionCode = acode;
}

synthesized attribute disambiguationGroupDcls :: [DisambiguationGroupSpec];
attribute disambiguationGroupDcls occurs on Root, RootSpec, AGDcls, AGDcl, ImportExportStmts;

aspect production disambiguationGroupDcl
top::AGDcl ::= 'disambiguation' 'group' id::Id_t w::With_kwd lc::LCurly_t terms::TermPrecList  rc::RCurly_t act::Action_kwd acode::ActionCode_c s::Semi_t
{
  top.disambiguationGroupDcls = [disambiguationGroupSpec(fName,terms.precTermList,acode.actionCode)];
}


aspect production attributeDclParser
top::AGDcl ::= pr::Parser_kwd at::Attribute_kwd a::Id_t ht::HasType_t te::Type act::Action_kwd acode::ActionCode_c s::Semi_t
{
  top.disambiguationGroupDcls = [];
}


aspect production lexerClassDecl
top::AGDcl ::= l::Lexer_kwd cl::Class_kwd id::Id_t s::Semi_t
{
  top.disambiguationGroupDcls = [];
}




aspect production defaultNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.disambiguationGroupDcls = [];			   
}

aspect production defaultClosedNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.disambiguationGroupDcls = [];			   
}

aspect production closeNonterminalDcl
top::AGDcl ::= c::Close_kwd q::QName  s::Semi_t
{
  top.disambiguationGroupDcls = [ ];			   
}

aspect production emptyRootSpec
top::RootSpec ::= 
{
  top.disambiguationGroupDcls = [];
}

aspect production consRootSpec
top::RootSpec ::= c1::Decorated Root c2::Decorated RootSpec
{
  top.disambiguationGroupDcls = c1.disambiguationGroupDcls +++ c2.disambiguationGroupDcls;
}

aspect production appendRootSpec
top::RootSpec ::= c1::Decorated RootSpec c2::Decorated RootSpec
{
  top.disambiguationGroupDcls = c1.disambiguationGroupDcls +++ c2.disambiguationGroupDcls;
}




aspect production attributeDclInh
top::AGDcl ::= i::Inherited_kwd  at::Attribute_kwd a::Id_t ht::HasType_t te::Type s::Semi_t
{
  top.disambiguationGroupDcls = [];
}

aspect production attributeDclSyn
top::AGDcl ::= sn::Synthesized_kwd  at::Attribute_kwd a::Id_t ht::HasType_t te::Type  s::Semi_t
{
  top.disambiguationGroupDcls = [];
}

aspect production importStmtsNone
top::ImportExportStmts ::=
{
  top.disambiguationGroupDcls = [];
}

aspect production importStmtsOne 
top::ImportExportStmts ::= im::ImportStmt
{
  top.disambiguationGroupDcls = [];
}

aspect production exportStmtsOne 
top::ImportExportStmts ::= ex::ExportStmt
{
  top.disambiguationGroupDcls = [];
}

aspect production importStmtsCons
top::ImportExportStmts ::= h::ImportStmt t::ImportExportStmts
{
  top.disambiguationGroupDcls = t.disambiguationGroupDcls;
}

aspect production exportStmtsCons
top::ImportExportStmts ::= h::ExportStmt t::ImportExportStmts
{
  top.disambiguationGroupDcls = t.disambiguationGroupDcls;
}

aspect production appendImportsExports
top::ImportExportStmts ::= fst::ImportExportStmts snd::ImportExportStmts
{
  top.disambiguationGroupDcls = fst.disambiguationGroupDcls +++ snd.disambiguationGroupDcls;
}

aspect production attributionDcl
top::AGDcl ::= at::Attribute_kwd a::QName oc::Occurs_kwd o::On_kwd nt::QName s::Semi_t
{
  top.disambiguationGroupDcls = [];
}

aspect production productionDcl
 top::AGDcl ::=
   a::Abstract_kwd p::Production_kwd id::Id_t ns::ProductionSignature
   body::ProductionBody
{
  top.disambiguationGroupDcls = [];
}

aspect production aspectAGDcl
 top::AGDcl ::=
   a::Aspect_kwd p::Production_kwd id::QName ns::AspectSignature
   body::ProductionBody
{
  top.disambiguationGroupDcls = [];
}

aspect production root
top::Root ::= gdcl::GrammarDcl ims::ImportExportStmts ags::AGDcls
{
  top.disambiguationGroupDcls = ags.disambiguationGroupDcls +++ ims.disambiguationGroupDcls;
}

aspect production agDclsOne
top::AGDcls ::= ag::AGDcl
{
  top.disambiguationGroupDcls = ag.disambiguationGroupDcls ;
}

aspect production agDclsCons
top::AGDcls ::= h::AGDcl t::AGDcls
{
  top.disambiguationGroupDcls = h.disambiguationGroupDcls +++ t.disambiguationGroupDcls;
}

aspect production agDclSeq
top::AGDcl ::= ag1::AGDcl ag2::AGDcl
{
  top.disambiguationGroupDcls = ag1.disambiguationGroupDcls +++ ag2.disambiguationGroupDcls;
}

aspect production agDclNone
top::AGDcl ::=
{
  top.disambiguationGroupDcls = [];
}

attribute disambiguationGroupDcls occurs on SyntaxStmt;

aspect production syntaxStmtsOne 
top::ImportExportStmts ::= syn::SyntaxStmt
{
  top.disambiguationGroupDcls = syn.disambiguationGroupDcls;
}

aspect production syntaxStmtsCons
top::ImportExportStmts ::= h::SyntaxStmt t::ImportExportStmts
{
  top.disambiguationGroupDcls = h.disambiguationGroupDcls +++ t.disambiguationGroupDcls;
}

aspect production syntaxAll
top::SyntaxStmt ::= s::Syntax_kwd pkg::QName se::Semi_t
{
  top.disambiguationGroupDcls = spec.disambiguationGroupDcls;
}

aspect production syntaxHiding
top::SyntaxStmt ::= s::Syntax_kwd  pkg::QName h::Hiding_kwd ns::NameList se::Semi_t
{
  top.disambiguationGroupDcls = spec.disambiguationGroupDcls;
}

aspect production terminalDcl
top::AGDcl ::= t::Terminal_kwd id::Id_t r::RegExpr s::Semi_t
{
  top.disambiguationGroupDcls = [];
}
