grammar silver:translation:haskelljava:concretesyntax;
import silver:base:cs:default;
import silver:base:core;
import silver:utils;

import silver:translation:ag:haskell;
--import silver:translation:haskelljava:core;

import silver:analysis:typechecking:core;
import silver:extension:easyterminal;

terminal Disambiguation_kwd 'disambiguation' lexer precedence = 5;
terminal Group_kwd 'group' lexer precedence = 5;

-- Separate 'TermPrecList' syntax if proper type-checking is made possible.
concrete production disambiguationGroupDcl
top::AGDcl ::= 'disambiguation' 'group' id::Id_t w::With_kwd lc::LCurly_t terms::TermPrecList  rc::RCurly_t act::Action_kwd acode::ActionCode_c s::Semi_t
{
  top.pp = "disambiguation group " ++ id.lexeme ++ " with { " ++ terms.pp ++ "} action " ++ acode.actionCode.pp ++ "\n";
  top.location = "[line: " ++ toString(id.line) ++ ", column: " ++ toString(id.column) ++ "] ";

  production attribute fName :: String;
  fName = top.grammarName.name ++ ":" ++ id.lexeme;

  production attribute fName_dashes :: String ; 
  fName_dashes = makeName(fName);

  top.defs = addTypeDcl(fName, disambiguationGroupTypeRep(fName_dashes), 
	     addFullNameDcl(id.lexeme, fName,
	     addOccursDcl("lexeme", fName,
 	     addOccursDcl("line", fName,
	     addOccursDcl("column", fName, emptyDefs())))));

  top.globalDefs = addTypeDcl(fName, disambiguationGroupTypeRep(fName_dashes),
	           addOccursDcl("lexeme", fName,
 	           addOccursDcl("line", fName,
	           addOccursDcl("column", fName, emptyDefs()))));

  local attribute er1 :: String;
  er1 = if length(getFullNameDcl(id.lexeme, top.env)) > 1
       then top.location ++ "Error: Name '" ++ id.lexeme ++ "' is already bound.\n"
       else "";	

  local attribute er2 :: String;
  er2 = if length(getTypeDcl(fName, top.env)) > 1
       then top.location ++ "Error: Type '" ++ fName ++ "' is already bound.\n"
       else "";	

  top.errors = er1 ++ er2 ++ terms.errors;
  top.typeErrors = terms.typeErrors;

  -- FIXME
  acode.env = appendDefsEnv(addTerminalAttrDefs(addThisDcl(fName,appendDefs(acode.defs,terms.defs))),top.env);
--  acode.env = appendDefsEnv(addFullNameDcl("lexeme","lexeme",addValueDcl("lexeme",stringTypeRep(),addThisDcl(fName,appendDefs(acode.defs,terms.defs)))), top.env);

  acode.signatureEnv = toEnv(terms.defs);
  acode.localsEnv = toEnv(acode.defs);

  acode.signatureNames = [fName];--terms.precTermList;
  acode.signatureTypes = generateSigTypeList(acode.signatureNames,acode.env);--generateSigTypeList(acode.signatureNames,top.env);

  acode.actionCodeType = disambigGroupActionType();
  

}

aspect production disambiguationGroupDcl
top::AGDcl ::= 'disambiguation' 'group' id::Id_t w::With_kwd lc::LCurly_t terms::TermPrecList  rc::RCurly_t act::Action_kwd acode::ActionCode_c s::Semi_t
{
  top.hasStartSymbol = false;

  top.haskell = @"";
  top.terminalDcls = [];			   
  top.parserUses = [];
  top.ruleDcls = [];
  top.ntDcls = [];

  top.easyRegsDefs = [];
--  top.agnosis = [];
}
