grammar silver:translation:haskelljava:concretesyntax;
import silver:base:cs:default;
import silver:base:core;

synthesized attribute ntName :: String;

nonterminal NTSpec with {ntName};

abstract production ntSpec
top::NTSpec ::= ntNm::String
{
    top.ntName = ntNm;
}

synthesized attribute ntDcls :: [NTSpec];
attribute ntDcls occurs on Root, RootSpec, AGDcls, AGDcl, ImportExportStmts;

aspect production defaultNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.ntDcls = [ntSpec(fName)];			   
}

aspect production defaultClosedNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.ntDcls = [ntSpec(fName)];			   
}

aspect production closeNonterminalDcl
top::AGDcl ::= c::Close_kwd q::QName  s::Semi_t
{
  top.ntDcls = [ ];			   
}

aspect production emptyRootSpec
top::RootSpec ::= 
{
  top.ntDcls = [];
}

aspect production consRootSpec
top::RootSpec ::= c1::Decorated Root c2::Decorated RootSpec
{
  top.ntDcls = c1.ntDcls +++ c2.ntDcls;
}

aspect production appendRootSpec
top::RootSpec ::= c1::Decorated RootSpec c2::Decorated RootSpec
{
  top.ntDcls = c1.ntDcls +++ c2.ntDcls;
}




aspect production attributeDclInh
top::AGDcl ::= i::Inherited_kwd  at::Attribute_kwd a::Id_t ht::HasType_t te::Type s::Semi_t
{
  top.ntDcls = [];
}

aspect production attributeDclSyn
top::AGDcl ::= sn::Synthesized_kwd  at::Attribute_kwd a::Id_t ht::HasType_t te::Type  s::Semi_t
{
  top.ntDcls = [];
}

aspect production importStmtsNone
top::ImportExportStmts ::=
{
  top.ntDcls = [];
}

aspect production importStmtsOne 
top::ImportExportStmts ::= im::ImportStmt
{
  top.ntDcls = [];
}

aspect production exportStmtsOne 
top::ImportExportStmts ::= ex::ExportStmt
{
  top.ntDcls = [];
}

aspect production importStmtsCons
top::ImportExportStmts ::= h::ImportStmt t::ImportExportStmts
{
  top.ntDcls = t.ntDcls;
}

aspect production exportStmtsCons
top::ImportExportStmts ::= h::ExportStmt t::ImportExportStmts
{
  top.ntDcls = t.ntDcls;
}

aspect production appendImportsExports
top::ImportExportStmts ::= fst::ImportExportStmts snd::ImportExportStmts
{
  top.ntDcls = fst.ntDcls +++ snd.ntDcls;
}

aspect production attributionDcl
top::AGDcl ::= at::Attribute_kwd a::QName oc::Occurs_kwd o::On_kwd nt::QName s::Semi_t
{
  top.ntDcls = [];
}

aspect production productionDcl
 top::AGDcl ::=
   a::Abstract_kwd p::Production_kwd id::Id_t ns::ProductionSignature
   body::ProductionBody
{
  top.ntDcls = [];
}

aspect production aspectAGDcl
 top::AGDcl ::=
   a::Aspect_kwd p::Production_kwd id::QName ns::AspectSignature
   body::ProductionBody
{
  top.ntDcls = [];
}

aspect production root
top::Root ::= gdcl::GrammarDcl ims::ImportExportStmts ags::AGDcls
{
  top.ntDcls = ags.ntDcls +++ ims.ntDcls;
}

aspect production agDclsOne
top::AGDcls ::= ag::AGDcl
{
  top.ntDcls = ag.ntDcls ;
}

aspect production agDclsCons
top::AGDcls ::= h::AGDcl t::AGDcls
{
  top.ntDcls = h.ntDcls +++ t.ntDcls;
}

aspect production agDclSeq
top::AGDcl ::= ag1::AGDcl ag2::AGDcl
{
  top.ntDcls = ag1.ntDcls +++ ag2.ntDcls;
}

aspect production agDclNone
top::AGDcl ::=
{
  top.ntDcls = [];
}

attribute ntDcls occurs on SyntaxStmt;

aspect production syntaxStmtsOne 
top::ImportExportStmts ::= syn::SyntaxStmt
{
  top.ntDcls = syn.ntDcls;
}

aspect production syntaxStmtsCons
top::ImportExportStmts ::= h::SyntaxStmt t::ImportExportStmts
{
  top.ntDcls = h.ntDcls +++ t.ntDcls;
}

aspect production syntaxAll
top::SyntaxStmt ::= s::Syntax_kwd pkg::QName se::Semi_t
{
  top.ntDcls = spec.ntDcls;
}

aspect production syntaxHiding
top::SyntaxStmt ::= s::Syntax_kwd  pkg::QName h::Hiding_kwd ns::NameList se::Semi_t
{
  top.ntDcls = spec.ntDcls;
}

aspect production terminalDcl
top::AGDcl ::= t::Terminal_kwd id::Id_t r::RegExpr s::Semi_t
{
  top.ntDcls = [];
}
