grammar silver:translation:haskelljava:concretesyntax;
import silver:base:cs:default;
import silver:base:core;

terminal Parser_kwd /parser/ lexer precedence = 5;

attribute actionCode occurs on RHSSpec;

abstract production rhsSpecAction
top::RHSSpec ::= fn::String ns::[String] gName::Decorated QName pm::Decorated OptProductionModifiers acode::ActionCode
{
   top.actionCode = acode;
   forwards to rhsSpec(fn,ns,gName,pm);
}

aspect production rhsSpec
top::RHSSpec ::= fn::String ns::[String] gName::Decorated QName pm::Decorated OptProductionModifiers
{
   top.actionCode = actionCodeEmpty();
}

concrete production attributeDclParser
top::AGDcl ::= pr::Parser_kwd at::Attribute_kwd a::Id_t ht::HasType_t te::Type act::Action_kwd acode::ActionCode_c s::Semi_t
{
  top.location = "[line: " ++ toString(pr.line) ++ ", column: " ++ toString(pr.column) ++ "] ";
  top.pp = "parser attribute " ++ a.lexeme ++ " :: " ++ te.pp ++ " ;" ;

  production attribute fName :: String;
  fName = top.grammarName.name ++ ":" ++ a.lexeme;

  top.defs = addValueDcl(fName, te.typerep,
             addParserAttrDcl(fName, 
	     addFullNameDcl(a.lexeme, fName,  emptyDefs())));

             --addValueDcl(fName,te.typerep,
             --addAttributeDcl(fName, te.typerep, 
             --addParserAttrDcl(fName, 
	     --addFullNameDcl(a.lexeme, fName,  emptyDefs())));

  top.globalDefs = addAttributeDcl(fName, te.typerep, 
             	   addParserAttrDcl(fName, emptyDefs()));

  local attribute er1 :: String;
  er1 = if length(getFullNameDcl(a.lexeme, top.env)) > 1
       then top.location ++ "Error: Name '" ++ a.lexeme ++ "' is already bound.\n"
       else "";	

  local attribute er2 :: String;
  er2 = if length(getAttributeDcl(fName, top.env)) > 1
       then top.location ++ "Error: Attribute '" ++ fName ++ "' is already bound.\n"
       else "";	

  local attribute er3 :: String;
  er3 = if !te.typerep.isParserAttrType
        then top.location ++ "Error: Type '" ++ te.typerep.typeName ++ "' not valid for a parser attribute.\n"
        else "";

  top.errors = er1 ++ er2 ++ er3 ++ te.errors;

  acode.actionCodeType = parserAttrActionType();


  -- FIXME
  acode.env = appendDefsEnv(addFullNameDcl(a.lexeme,fName,
                             addValueDcl(fName,te.typerep,
                              addThisDcl(fName,acode.defs))),top.env);

--appendDefsEnv(addFullNameDcl("currentToken","currentToken",addValueDcl("currentToken",stringTypeRep(),addThisDcl("currentToken",emptyDefs()))), top.env);

  -- FIXME
  --acode.env = appendDefsEnv(addThisDcl(fName,terms.defs)), top.env);

  acode.signatureEnv = emptyEnv();
  acode.localsEnv = toEnv(acode.defs);

  acode.signatureNames = [fName];
  acode.signatureTypes = generateSigTypeList(acode.signatureNames,acode.env);

}
