grammar silver:translation:haskelljava:concretesyntax;
import silver:base:core;
import silver:base:cs:default;
import silver:extension:collection only Contains_t;
import silver:analysis:typechecking:core;
import silver:utils;
import silver:translation:ag:haskell only haskell ;
import silver:extension:easyterminal only easyRegsDefs;


import silver:translation:haskelljava:core;

synthesized attribute hasPrecedenceOperator :: Boolean;
synthesized attribute precedenceOperator :: String;

attribute hasPrecedenceOperator occurs on OptProductionModifiers,ProductionModifier,ProductionModifiers,RHSSpec;
attribute precedenceOperator occurs on OptProductionModifiers,ProductionModifier,ProductionModifiers,RHSSpec;

aspect production rhsSpec
top::RHSSpec ::= fn::String ns::[String] gName::Decorated QName m::Decorated OptProductionModifiers
{
   top.hasPrecedenceOperator = m.hasPrecedenceOperator;
   top.precedenceOperator = m.precedenceOperator;
}

aspect production optProductionModifiersNothing
top::OptProductionModifiers ::= 
{
  top.hasPrecedenceOperator = false;
}

aspect production optProductionModifiersSomething
top::OptProductionModifiers ::= pm::ProductionModifiers
{
  top.hasPrecedenceOperator = pm.hasPrecedenceOperator;
  top.precedenceOperator = pm.precedenceOperator;
} 

aspect production productionModifiersCons
top::ProductionModifiers ::= h::ProductionModifier c::Comma_t t::ProductionModifiers
{
  top.hasPrecedenceOperator = h.hasPrecedenceOperator || t.hasPrecedenceOperator ;
  top.precedenceOperator = if h.hasPrecedenceOperator
                           then h.precedenceOperator
                           else if t.hasPrecedenceOperator
                                then t.precedenceOperator
                                else error("productionModifiersCons -- Should not get here");
}
aspect production productionModifierSingle
top::ProductionModifiers ::= pm::ProductionModifier
{
  top.hasPrecedenceOperator = pm.hasPrecedenceOperator;
  top.precedenceOperator = pm.precedenceOperator;
}

aspect production productionModifierPrecedence
top::ProductionModifier ::= p::Precedence_kwd e::Equal_t i::Int_t
{
  top.hasPrecedenceOperator = false;
}

aspect production productionModifierLayout
top::ProductionModifier ::= l::Layout_kwd e::Equal_t lc::LCurly_t terms::TermPrecList rc::RCurly_t
{
  top.hasPrecedenceOperator = false;
}

concrete production productionModifierOperator
top::ProductionModifier ::= p::Precedence_kwd o::Operator_kwd e::Equal_t t::QName
{
 top.hasParserPrec = false;
 top.parserPrec = 0;
 top.hasCustomLayout = false;
 top.customLayout = [];
 top.hasPrecedenceOperator = true;

 production attribute fullNameItem :: [Decorated EnvItem];
 fullNameItem = getFullNameDclOne(t.name,top.env);

 production attribute typeItem :: [Decorated EnvItem];
 typeItem = getTypeDclOne(t.name,top.env);

 top.precedenceOperator = head(fullNameItem).fullName;

 top.errors = if null(fullNameItem)
                then t.location ++ " Error: Name '" ++ t.name ++ "' is not declared.\n"
                else "";

-- Does not seem to be any type-checking on this sort of thing.
 top.typeErrors = --if null(typeItem) || (!head(typeItem).typerep.isTerminal)
                     --then t.location ++ " Error: '" ++ t.name ++ "' is not a terminal.\n"
                     --else
                     "";
}