grammar silver:translation:haskelljava:concretesyntax;
import silver:base:cs:default;
import silver:base:core;
import silver:base:type:anytype;

import silver:extension:list;
import silver:translation:ag:haskell ;
--import silver:translation:haskelljava:type:anytype;

synthesized attribute isLexerClass :: Boolean;

attribute isLexerClass occurs on TypeRep;

function lexerClassTypeRep
Decorated TypeRep ::= n::String
{
  return decorate internal_lexerClassTypeRep(n) with {};
}

abstract production internal_lexerClassTypeRep
top::TypeRep ::= n::String
{
  top.typeName = n;
  top.type_fullname = n;
  top.pp = "Lexer class " ++ n ;
  top.isLexerClass = true;
  forwards to internal_defaultTypeRep();
}
 
synthesized attribute isParserAttrType :: Boolean;
synthesized attribute parserAttrType :: String;

attribute isParserAttrType occurs on TypeRep;
attribute parserAttrType occurs on TypeRep;

aspect production internal_integerTypeRep
top::TypeRep ::= 
{
   top.isParserAttrType = true;
   top.parserAttrType = "Integer";
}

aspect production internal_stringTypeRep
top::TypeRep ::= 
{
   top.isParserAttrType = true;
   top.parserAttrType = "String";
}

aspect production internal_listTypeRep
top::TypeRep ::= uf::Integer e::Boolean tr::Decorated TypeRep
{
   top.isParserAttrType = tr.isParserAttrType;
   top.parserAttrType = if tr.isParserAttrType
                        then "[" ++ tr.parserAttrType ++ "]"
                        else "";
}

aspect production internal_anyTypeTypeRep
top::TypeRep ::= 
{
  top.isParserAttrType = true;
  top.parserAttrType = "AnyType";
}

aspect production internal_defaultTypeRep
top::TypeRep ::=
{
  top.isParserAttrType = false;
  top.parserAttrType = "";
}

synthesized attribute isDisambiguationGroup :: Boolean;
attribute isDisambiguationGroup occurs on TypeRep;

function disambiguationGroupTypeRep
Decorated TypeRep ::= n::String
{
  return decorate internal_disambiguationGroupTypeRep(n) with {};
}

abstract production internal_disambiguationGroupTypeRep
top::TypeRep ::= n::String
{
  top.typeName = n;
  top.type_fullname = n;
  top.pp = "Disambiguation group " ++ n ;
  top.isDisambiguationGroup = true;
  forwards to internal_defaultTypeRep();
}
