grammar silver:utils:ale:host ;

nonterminal Options with pp ;
nonterminal Option  with pp ;

-- Options --
-------------
synthesized attribute exe_name :: String occurs on Options, Option ;
synthesized attribute driver_name :: String occurs on Options, Option ;
synthesized attribute build_lines :: String occurs on Options, Option ;
synthesized attribute silver_name :: String occurs on Options, Option ;
synthesized attribute separate_ghc :: Boolean occurs on Options, Option ;
synthesized attribute do_ghc :: Boolean occurs on Options, Option ;

terminal Exe_t    'executable:' ;
terminal Driver_t 'driver:' ;
terminal BuildTest_t  'build.test:' ;
terminal Should_t 'should' ;
terminal Fail_t 'fail' ;
terminal Silver_t 'silver:' ;
terminal Seprate_GHC_t 'separate_ghc:' ;
terminal Do_GHC_t 'do_ghc:' ;

concrete production opts_none
opts::Options ::=
{
 opts.pp = "" ;
 opts.exe_name = "" ;
 opts.driver_name = "" ;
 opts.build_lines = "" ;
 opts.silver_name = "" ;
 opts.separate_ghc = true ;
 opts.do_ghc = false ;
}

concrete production opts_cons
opts::Options ::= opt::Option opts_tail::Options
{
 opts.pp = opt.pp ++ opts_tail.pp ;
 opts.exe_name = opt.exe_name ++ opts_tail.exe_name ;
 opts.driver_name = opt.driver_name ++ opts_tail.driver_name ;
 opts.build_lines = opt.build_lines ++ "\n" ++ opts_tail.build_lines ;
 opts.silver_name = opt.silver_name ++ opts_tail.silver_name ;
 opts.separate_ghc = opt.separate_ghc || opts_tail.separate_ghc ;
 opts.do_ghc = opt.do_ghc || opts_tail.do_ghc ;
}

abstract production opt_empty
opt::Option ::=
{
 opt.exe_name = "" ;
 opt.driver_name = "" ;
 opt.build_lines = "" ;
 opt.silver_name = "" ;
 opt.separate_ghc = false ;
 opt.do_ghc = false ;
}


concrete production exe_opt
opt::Option ::= exe::Exe_t n::Id_t
{
 opt.pp = exe.lexeme ++ " " ++ n.lexeme ++ "\n";
 opt.exe_name = n.lexeme ;
 forwards to opt_empty();
}

concrete production driver_opt
opt::Option ::= d::Driver_t n::Id_t
{
 opt.pp = d.lexeme ++ " " ++ n.lexeme ++ "\n";
 opt.driver_name = n.lexeme ;
 forwards to opt_empty();
}


concrete production build_fail_opt
opt::Option ::= b::BuildTest_t  s::Should_t f::Fail_t
{
 opt.pp = b.lexeme ++ " " ++ s.lexeme ++ " " ++ f.lexeme ++ "\n";
 opt.build_lines = "BUILD SHOULD FAIL" ;
 forwards to opt_empty();
}

concrete production silver_opt
opt::Option ::= s::Silver_t n::Id_t
{
 opt.pp = s.lexeme ++ " " ++ n.lexeme ++ "\n";
 opt.silver_name = n.lexeme ;
 forwards to opt_empty();
}

concrete production separate_ghc_opt
opt::Option ::= s::Seprate_GHC_t
{
 opt.pp = s.lexeme ++ "\n";
 opt.separate_ghc = true ;
 forwards to opt_empty();
}

concrete production do_ghc_opt
opt::Option ::= s::Do_GHC_t
{
 opt.pp = s.lexeme ++ "\n";
 opt.do_ghc = true ;
 forwards to opt_empty();
}
